Introduction

Library Clinic v1.0

What Library Clinic does

Library Clinic is an iTunes® library assistant used to edit and manipulate the tag content and file locations of files listed in the iTunes XML library file. It offers a more powerful and versatile tag editor and file renamer than corresponding functions found in iTunes itself, and makes it easy to move specific files, or even a whole library, to another location without confusing iTunes. You can use it to make multiple, alternative versions of a library and then activate any one you want at any particular time. You can catch-up a library with tag changes, or vice versa, with just a single mouse click, and it contains an integrated playlist editor.

Library Clinic doesn't work directly on the iTunes library itself, but instead works on a copy of it in memory. Changes you make are not applied to the actual library until you tell it to, or until you allow it to. When changes are applied, a backup of the original library is created which can be restored at any time.

Most people are aware that iTunes keeps two copies of its library. The first is a compressed volume called "iTunes Library.itl," and this is the copy that iTunes actually uses and works from. The second copy is a backup of the first, a copy that is stored in human-readable XML format, in a file named "iTunes Music Library.xml." This program operates only on this second file and takes advantage of iTunes' willingness to load from this backup copy if the primary file, the compressed copy, is found to be unusable.

What Library Clinic doesn't do

Restoring an iTunes' library from a backup copy has some inherent limitations. Even restoring from an unaltered iTunes backup will not restore a library to the exact state it was in originally, since not every characteristic and nuance of the original is represented in the backup. If you're a Podcast enthusiast, for example, you'll be disappointed that subscription information is not preserved in backups. Nor can iTunes be induced to put podcast files back into the podcast category, even if that's where they were originally (although, you can have them placed in a podcast playlist). Party Shuffle lists, as another example, are not restored from a backup, even though a copy may exist there. Instead iTunes recreates this list anew each time a backup loads. When iTunes loads from a backup, many read-only data fields are recreated from scratch during the restore process, regardless of whether they exist in the backup or not, or whether they contain valid information. For this reason, not every data field can be preserved when iTunes is made to restore from an XML backup copy. Fortunately, most of the fields in this category are technical information fields, such as bitrate, sample rate and the like, and these types of fields are recreated by iTunes exactly as they were in the original library anyway. A notable exception is the "Date Added" field; iTunes will set the "Date Added" field for every file it restores to the date and time the backup file is restored, rather than to any original date and time that may be found in the backup.

In general, because Library Clinic works on a backup copy of the iTunes library rather than on the actual library itself, the inherent limitations of the restoration process will make this program a "tool" for some, rather than a complete solution. Its suitability for creating iTunes libraries via backup files will depend largely upon how iTunes is used by the individual user.

Getting started

The best way to get a quick overview of Library Clinic's operation is to browse topic Main Editor.

Support:

clinic@kevesoft.com

This help file was last updated 5/24/2010 for Library Clinic v1.0.9.

Copyright © 2008-2010 Keve Zoller. All rights reserved.


Auto-Edit Options Panel

Access: Menu > File > Auto-Edit Options, <Ctrl+O, [image] button on Top Toolbar B

Use the Options Panel to control the Main Editor's auto-editing behavior when manually editing tags. This is a movable panel brought into view by either 1) clicking the Options Panel Button [image] on the Top Toolbar B, or 2) executing the shortcut sequence <Ctrl+O>, or 3) choosing Main Menu > File > Options. Once opened, any of these options will also close the panel, or you can click on the panel itself to close it.

Editor Auto-Edit Options

Editor auto-edit options are applied when performing individual cell edits, either manually or when using automated functions that operate on multiple rows at one time.

Auto-Cap (button [image] located on Top Toolbar B): Automatically capitalize all words in tag text or a filename after it is edited. The "Apply To..." settings described below govern which tag fields have this option applied. Behavior is modified by the Default Capitalization Options defined in the Capitalization Editor (click small button [image] for access), as well as the status of the Exact-Cap and Anti-Cap options described below. Auto-Cap can be enabled or disabled by clicking the Auto-Cap button [image]. Note that the capitalization of filename extensions is not controlled by Auto-Cap; instead, extensions are capitalized in accordance with the extension capitalization setting [image] found on the Rename Page. Auto-Cap is not applied to multi-line tag fields (see "Multi-line Fields" in heading "Apply to..." below).

Anti-Cap: Prevent capitalization of all words and phrases in the active Anti-Capitalization List. Single words listed must be found with a space on both sides in order to be acted upon, while phrases must be preceded by a space. Words that fall at the beginning of text are exempt from this option, as are words that have a parenthesis or bracket immediately preceding or following them. In addition to activation with the checkbox shown, the option may also be enabled or disabled with the "Enable Anti-Cap List' checkbox on the Capitalization Editor. By default, Anti-Cap is applied whether or not option Auto-Cap above is enabled. However, you can prevent its operation while Auto-Cap is not active by checking "Only apply when Auto-Cap is enabled" on the Capitalization Editor.

Exact-Cap: Capitalize all words and phrases listed in the Exact-Capitalization List exactly as shown in the list. Listed words must be found with a space on both sides in order to be acted upon. In addition to activation with the checkbox shown, the option may also be enabled or disabled with the "Enable Exact-Cap List' checkbox on the Capitalization Editor. By default, Exact-Cap is applied whether or not option Auto-Cap above is enabled. However, you can prevent its operation while Auto-Cap is not active by checking "Only apply when Auto-Cap is enabled" on the Capitalization Editor.

Trim leading space: Automatically remove spaces at the beginning of a tag field.

Trim overlength: Tag field length is limited in ID3v1 tags. For Title, Artist, and Album fields the maximum number of characters is 30. The Comment is allowed 28 characters (for tag version 1.1). The Year field can have up to 4 characters, while the Track is allowed only 2. The Genre is stored as an index number rather than a text value, so it is not subject to a length restriction. These numbers are a tag design characteristic for ID3v1 tags and cannot be changed. Although the Editor will allow you to enter more characters into an ID3v1 data cell than the maximum allowed in the tag, no more than the maximum can actually be written into the tag. Any excess is lost. This option provides visual feedback when the data entered exceeds the design limit, since the excess is automatically removed as the cell is vacated.

Trim trailing space: Automatically remove spaces at the end of a tag field.

'X -> 'x: Whenever one of the characters D, M, S, or T (followed by a space or at end-of-text) is found to occur after an apostrophe, or one of the characters L, R, or V is found to occur after an apostrophe, convert the letter to lower case. Thus, for example, the contraction "can't" is capitalized as "Can't" and not "Can'T" when enabled. Note that this option takes precedence over the more general option to auto-cap after all apostrophes found in "Default Capitalization Options" on the Capitalization Editor.

'Xx -> 'xx: Whenever one of the letter sequences VE, LL, or RE (followed by a space or at end-of-text) is found to occur after an apostrophe, convert it to lower case. Thus, for example, the contraction "we've" is capitalized as "We've" rather than "We'Ve" when enabled. Note that this option takes precedence over the more general option to auto-cap after all apostrophes found in "Default Capitalization Options" on the Capitalization Editor.

'Mcx -> McX': Capitalize the next letter following the expression "Mc". Thus, for example, the name "mcguire" is capitalized as "McGuire" rather than "Mcguire."

'& xxx' -> 'and xxx': Automatically convert an ampersand ("&") to the word "and" when found in the words "and his," "and the," or "and a."

Note: the auto-edit features listed above are applied in the order shown.

Apply To...

Titles: Apply enabled options to File Name, Original File Name, Title, Orchestra/Band, Subtitle, Publisher, Show, and Sort Show fields.

People: Apply enabled options to Artist, Sort Artist, Original Artist, Album Artist, Sort Album Artist, Lyricist, Original Lyricist, Encoded By, Modified By, Conductor, Composer, Sort Composer, Involved People, Musicians, Owner-Seller, and Commercial-Seller fields.

Albums: Apply enabled options to the Album, Original Album, and Sort Album fields.

Multi-line Fields: Apply all enabled options (with the exception of Auto-Cap) to Comment, User Text, MusicMatch Bio, and Lyrics fields.

Tag Synchronization

'V1 syncs with V2': Propagate changes made to MP3 ID3v2 tag fields into corresponding ID3v1 tag fields, where applicable. If the file does not contain an ID3v1 tag, one is created.

'V2 syncs with V1': Propagate changes made to MP3 ID3v1 tag fields into corresponding ID3v2 tag fields, where applicable. If the file does not contain an ID3v2 tag, one is created.

Use the hint ON/OFF button to enable or disable hints presented for items listed on the Options Panel.


Auto-Extracting Text from Name-to-Tag

Access: Main Editor multi-file popup menu

Single-Column Name-To-Tag Extractions -

Name-to-tag extractions are performed by using the upper section of the Editor's Multi-tag Popup menu, as shown above. The process operates only on selected rows, and upon the specific column that is right-clicked to produce the popup. In the example above, rows 1, 2, and 4 have been selected and are highlighted, so these are the only rows that will be operated upon. The Artist column has been right-clicked, which causes its column header to become highlighted. In this example above, the Artist field in files 1, 2, and 4 will receive data from an extraction performed.

Extractions in Library Clinic are based on the idea that any file name can be perceived as if it were composed of a series of "text blocks" isolated from each other by some type of "separator." For example, consider the following file name:

Big Daddy - Eye of the Tiger.mp3

A simple way to view this file name is to envision it composed of two blocks of text, "Big Daddy " and " Eye of the Tiger," with each block isolated from the other by a hyphen. The hyphen, then, is the "Separator." In Library Clinic, a Separator can be chosen to be a hyphen, a comma, a period, a space, or an underbar, among others. Thus, the filename above could also be viewed as being composed of seven blocks of text, with each block isolated from its neighbors by a "space" character. To create tag data from filenames or path names, you first choose an appropriate Separator, select the rows you want to extract data into, right-click the mouse on the column into which you want to extract the data, and then choose from the popup menu at which occurrence of the Separator you want the data extraction process to begin. You can also choose where you want it to end - see Extract to below. The choice of Separator to use can be specified at several locations throughout the program: via the popup menu's "Separator" section itself (see below), the Main Menu's "Separator" section, a popup menu on the Status Bar, the Rename Page, or by choosing one on the Separator Toolbar.

Extract 1st: Extracts text starting from the beginning of a name and ending at the first occurrence of a Separator.

Extract 2nd: Extracts text from between the first Separator found in a name and the second.

Extract 3rd: Extracts text from between the second and third Separators.

More: Use the top section of this submenu to extract text from between subsequent Separators up to the twelfth (or to extract all text after the last Separator):

The bottom section begins with a an "Extract Track" selection, useful for extracting track numbers from file names when track numbers are not located conveniently between Separators. This option will look for and extract the first one- or two-digit number found in file names. Numbers found must be either 1) at the beginning of a name, and have a space or hyphen following, or 2) at the end of a name and have a space or hyphen before, or 3) inside a name and have a space or hyphen both before and after. The last three selections are used to extract text from between, respectively, the first set of parenthesis, square brackets, or curly brackets found in a filename.

Separator: Selects the Separator to search for in names to determine where one piece of extraction text begins, where it ends, and where the next begins. By default, the Separator chosen here is synchronized with the one shown and selectable on the Rename Page, the Main Menu, and elsewhere. If you change the Separator in one location it is automatically changed in the others. You can, however, choose to allow assignment of an individual Separator to the Editor page, and another for the Rename page (see the Behavior section of Preferences). The active Separator is always shown in the Status Bar, and you can click on it there to select another via popup menu.

[ - ] A dash with a space on each side

[-] A dash with no spaces on either side

[- ] A dash with a space on the right side

[ -] A dash with a space on the left side

[ _ ] An underbar character

[ . ] A period

[ , ] A comma

[ , ] A comma with a space on the right side

[ ~ ] A tilde with a space on each side

[~] A tilde with no spaces on either side

[ ] A space

Several other Separator-related tools and options are provided in this section.

Extract from...: Selects the data source for the extraction of data into tags.

File Name: Tag data are created by extracting it from each file's file name (the current folder path shown on the Top Toolbar B is colored black when this option is active).

Folder Name: Tag data are created by extracting it from file paths (the current folder path shown on the Top Toolbar B is colored red when this option is active). The backslash character is always used as the Separator for this type of extraction.

Extract to...: Determines how the end-of-data point is determined in the extraction process. By default, end-of-data is located one character before the beginning of the next Separator (or the end of the name itself, if that comes first), but three additional choices are available.

1st separator: This is the default setting. End-of-data occurs at the first occurrence of the active Separator.

As an example, assume " - " is chosen as Separator when extracting text from filename

Bach, J.S. - Sonata BWV 526 - 03 Allegro - Organ Works.mp3,

Right-clicking the "Title" column and choosing "Extract 1st" from the Popup menu (described above) extracts

Bach, J.S.

into the file's "Title" tag field. In other words, all text from the beginning of the name up to the occurrance of the first Separator is extracted into the Title column.

2nd separator: Data located between any Separator and the second one found after it is extracted. (A small LED ( [image]) on the Top Toolbar B is turned on when this selection is active.)

As an example, for the file named

Bach, J.S. - Sonata BWV 526 - 03 Allegro - Organ Works.mp3,

right-clicking the "Title" column and choosing "Second" on this popup menu extracts

Sonata BWV 526 - 03 Allegro

into the file's "Title" tag field. Note here that the first Separator in the name defines where the second block of text begins, while the second defines where it ends.

3rd separator: Data located between any Separator and the third one found after it is extracted. (A small LED ( [image]) on the Top Toolbar B is turned on when this selection is active.)

As an example, we assume this time that a "space" is the active Separator. For the file named

Casey Crime Photographer 47 05 08 The Laughing Killer.mp3,

right-clicking the "Comment" column and choosing "Fourth" on the Popup extracts

47 05 08

into the file's "Comment" tag field. Note that if Number Grouping (described below) were enabled, "470508" would be extracted.

end of file name: Data located between any Separator and the end of the name is extracted. (A small LED ( [image]) on the Top Toolbar B is turned on when this selection is active.)

As an example, and with " - " again as the Separator, for a file named

Bach, J.S. - Sonata BWV 526 - 03 Allegro - Organ Works.mp3,

right-clicking the "Title" column and choosing "Second" on this Popup extracts

Sonata BWV 526 - 03 Allegro - Organ Works

into the file's "Title" tag field.

Number Tools: Filenames sometimes contain one or more numbers "sandwiched in" between other text (numerical dates, for example), which may also contain spaces or symbol characters separating them from one another, or from adjacent text. This can make it more difficult to extract neighboring text, or the numbers themselves. By applying one or more of the following three tools beforehand, extraction of the desired text can be simplified. Since they actually alter the filenames themselves when applied, however, they are typically used in cases where files will be renamed again anyway, using extracted data.

For each function, the file name "Casey Crime Photographer 1-05-2006 The Laughing Killer.mpc" is used as an example:

'numbers' --> '-numbers': Adds a Separator to the front of all non-leading numbers, or groups of numbers (a leading number is a number that appears at the very start of data). Result:

Casey Crime Photographer-1-05-2006 The Laughing Killer.mpc

'numbers' --> 'numbers-': Adds a Separator to the end of all non-trailing numbers, or groups of numbers (a trailing number is a number that appears at the very end of text). Result:

Casey Crime Photographer 1-05-2006-The Laughing Killer.mpc

'num-ber-s' --> '-numbers-': Removes all non-alphabetic characters ("symbol" characters) from text found to be made up only of numbers and symbols. Result:

Casey Crime Photographer 1052006 The Laughing Killer.mpc

Number Grouping: When enabled, names used for name-to-tag extractions have all three "Number Tools" described above applied to them during the extraction process. Unlike when using those three tools individually, the actual filenames from which the text is obtained are not altered by the process. As an example, when this option is enabled, the file name

Casey Crime Photographer 47-05-08 The Laughing Killer.mp3

is treated as if it instead reads

Casey Crime Photographer-470508-The Laughing Killer.mp3,

for the purpose of extracting text. The filename itself is not altered. This allows "Casey Crime Photographer" and "The Laughing Killer" to be treated as if they were isolated from all the numerical data by Separators. Then, by using "Extract 1st" on the popup menu the text "Casey Crime Photographer" can be extracted into, say, the Album field, and "Extract 3rd" can extract "The Laughing Killer" into the Title field (here assuming "-" is the active Separator).

The Number Grouping LED ( [image]) on the Top Toolbar B is turned on when this option is active.

Multi-Column Name-To-Tag Extractions -

Multi-Extract: Extracts filename text into multiple tag fields at one time. When this option is chosen, the user is presented with the list of naming templates created and listed on the Rename Page (excluding any templates that involve path changes). Choose any template listed to extract Separator-delimited data from filenames into the tag fields contained in the chosen template. For example, consider the following file name:

Big Daddy - Eye of the Tiger.mp3

Highlighting this file's row and choosing Auto Extract > "Artist - Title" from the template list would extract "Big Daddy" into the Artist column and 'Eye of the Tiger' into the Title column.

If there are more tag fields contained in the template than there are Separator-delimited pieces of text in the name, extraction simply terminates after the last Separator is found. Thus in the example above, using a template "Artist - Title - Track" would produce the same result. Brackets and spaces in templates are ignored by this process; so, for example, templates "Album [Track] - Artist - Title," "Album-Track-Artist-Title," and "Album - Track - Artist - Title" will all produce the same result. Like most multi-file functions in Library Clinic, this function operates on all files if no rows are selected, or just selected rows if one or more rows are highlighted.

Refer to heading Multi-Field Popup Menu in topic Main Editor for information about how to use the other functions shown on this popup menu.


Auto-Renaming Files

Access: Menu > View > Rename Page, Rename Tab, <Alt+R>

The Rename Page

Use the Rename Page to rename a complete folder of files at one time, giving each file a name derived from tag data applied to a renaming template.

In the figure above, the renaming template shown is "Artist - Title - Year.mp3." Up to seven tag fields can be included in any template made. Any number of templates can be created and saved in the Saved Templates list. The list always includes two generic, default templates that cannot be removed: "Artist - Title" and "Title - Artist." Create others by using the Template Controls shown above and discussed below.

Begin by clearing the Selected Template box with its Clear button. Use the Build Template drop-down list to Add tag fields to the Selected Template box, one at a time, in any order you choose. See heading File Renaming Controls below for a detailed description of the operation of each control.

After building or selecting a naming template, preview proposed file names by pressing the Preview button. When viewing Tags rather than iTunes and only MP3s are listed, the Data Source Button [image] on the Top Toolbar B can be used to toggle the tag data source between tags ID3v1 and ID3v2 (otherwise, MP3 renames use whatever data is being shown on the Editor page). New names created are shown in the Preview Window on the right. Any number of consecutive previews can be performed before actually renaming files. Previews can be reversed one-by-one with the Undo button beneath the Preview button.

When a preview is produced, each proposed filename is scanned for one of three possible conditions that might prevent a file from being successfully renamed in accordance with the renaming template being used. A descriptive "flag" is placed in front of each name found with one of these potential problems:

***NO DATA*** None of the tag fields used for renaming were found to contain text. Files with this designation cannot be renamed unless the name is manually edited and approved (right-click on the name and choose "Edit" from the popup).

***PARTIAL DATA*** One or more (but not all) tag fields used as the source for filename text have been found to be empty of text. Whether or not a file is allowed to be renamed using partial data is ordinarily optional and depends upon the setting of the Allow partial data option (see below). However, if a renaming operation involves Directory Restructuring (that is, if files are to be relocated as well as renamed), partial-data files are not allowed to be renamed, regardless of option settings. As with the "No Data" exception above, filenames with this flag can be manually edited to bring them into compliance.

***ILLEGAL DATA*** Tag text used to rename a file has been found to contain one or more illegal characters that Windows will not allow as part of a filename ( \ , / , : , * , ? , " , < , > , and | ). Files with this designation cannot be renamed unless manually edited, defects removed, and the name is approved for renaming. You can elect to either prevent a renaming operation entirely when one of these defects is present, or you can have the program simply skip them as files are renamed (see option Stop on illegals below).

When all filenames scheduled for renaming are found to be fault free, the Rename button is turned GREEN. If one or more files have potential problems but renaming can proceed anyway, the button is turned YELLOW. If one or more new names contain illegal characters (and Stop on illegals is active - see below), then the button is turned RED. When red, renaming cannot proceed without manually editing offending names to remove or replace illegal characters. To edit, right-click or double-click on a filename and choose "Edit" from the popup menu.

Checkboxes are provided for each new name to allow specific files to be included or excluded from the naming process. When satisfied with new names, click the Rename button to have allowed files renamed to the proposed names as shown. During lengthy rename operations, renaming can be paused or terminated by clicking anywhere on the Preview Window or Editor, whichever is applicable. After completion, a rename operation can be reversed, if desired, by clicking the Undo button [image] on the right side of Top Toolbar B.

Note that sorting the Editors by filename reduces the time required to perform Rename Previews, file renames, and other multi-file operations. The program uses a row-search algorithm that increases in efficiency with the degree to which the Editors are fully sorted by filename, either ascending or descending.

File Renaming Controls -

Selected Template: The naming scheme or template applied to each listed file when the Preview or Rename buttons are clicked. For example, if the selected template is "Artist - Title.mp3," then new file names are constructed by first 1) retrieving whatever text is in the Artist tag field, then 2) appending to this a hyphen with a space on each side, and then 3) adding to this whatever text is in the Title field. Finally, a file extension is added.

Clear: Removes all text from the Selected Template box in preparation for creating or loading a new one.

Save: Saves the current Selected Template into the list of Saved Templates so it can be recalled at a later time.

Saved Templates: A customizable list of stored, selectable file renaming templates. Add new ones by using the Save option above.

Delete: Removes the template currently shown from the Saved Templates list.

Save: Saves the Saved Templates list to a backup copy restorable with the Restore button described below.

Load: Clears the current Saved Templates list and reloads it from a backup list created with the Save button above.

Build Template: Use to create your own renaming templates in the Selected Template box. Many tag fields are represented in plain and several bracketed styles in the pull-down list. Select a field/style combination from the list and click the Add button to append it to the end of the template displayed in the Selected Template box.

Add: Appends the selected field to the end of the template in the Selected Template box.

The presence of a "plus" symbol in a style indicates that two fields are being combined into one, with a single space character to be placed in between. No Separators will be inserted between the two fields when using one of these styles.

Separator: Selects the field delimiter to be used in renaming templates. By default, the Separator selected here is synchronized with the one used on the Editor page; if you change it in this location it is changed there also, and vice versa. You may, however, specify in the Preferences Behavior section that each of these two pages be allowed to have its own Separator. The active Separator for each page is always shown in the Status Bar at the bottom of the program. You can click there to select another via popup menu.

[ - ] A dash with a space on each side

[-] A dash with no spaces on either side

[- ] A dash with a space on the right side

[ -] A dash with a space on the left side

[ _ ] An underbar character

[ . ] A period

[ , ] A comma

[, ] A comma with a space on the right side

[ ~ ] A tilde with a space on each side

[~] A tilde with no spaces on either side

[ ] A space

Bracket Style: Use this pull-down list to select how Separators should be placed around bracketed data (i.e., tag data that's enclosed in parenthesis ( ), square brackets [ ], or curly braces {} ). Four choices are available:

( ) - : place a Separator on the right but none on the left

- ( ) : place a Separator on the left but none on the right

- ( ) - : place a Separator on both sides

( ) : place a Separator on neither side

By default, consecutive bracketed items are treated as a single item for the purposes of determining placement of Separators. Thus, in the following example (which uses Bracket Style 3 above), where the fields [Track] and (Genre) are placed consecutively, brackets appear on the sides but not in between:

"Album - [Track] (Genre) - Title.mp3"

You can override this default behavior to have a Separator added between consecutive bracketed fields by using the Bracket separators option below.

Add Backslash [image]: Appends a backslash "\" character to the text in the Selected Template box. The presence of this character indicates that Directory Restructuring is to be performed, and that all text to the left of the backslash is to be interpreted as a path name for relocating a renamed file. As an example, suppose you are working in folder "C:\MP3" and you have constructed the following template for renaming files:

"Artist\Album\Track - Title.mp3"

All files are renamed to "Track - Title," while the data in each file's "Artist" and "Album" fields are used to find or create a new storage location beneath folder "MP3," for each renamed file in that particular folder. As a specific case, say a file's Artist field contains "Bee Gees," its Album field contains "Best Of," its Title is "Nights On Broadway," and its Track number is "8." By default, the file is renamed and relocated as

"C:\MP3\Bee Gees\Best Of\08 - Nights On Broadway.mp3."

Rather than using the folder in which each file resides as the root folder beneath which subfolders are created and into which renamed files are moved ("C:\MP3" in this example), you can specify a default path for auto-creating subfolders and auto-moving renamed files into (see "Rename Root Folder" on the first page of Preferences).

Extension Capitalization [image] : Click button to toggle capitalization of file extensions through three possible options: mp3, Mp3, or MP3 (actual extension name will vary with the file type or types listed).

Bracket separators ) - (: Determines whether consecutive bracketed items in series have Separators placed in between them or not. When checked, the example given above in "Bracket Style" instead becomes:

"Album - [Track] - (Genre) - Title.mp3"

Caps: Selects the capitalization style for new filenames.

Capitalize: Capitalize each word in a new filename. Tag text used for renaming is capitalized for specific categories of tag fields only and on a field-by-field basis, in accordance with the "Apply to..." settings found on the Auto-Edit Options Panel. Capitalizations performed will pick up any Anti-Capitalization and/or Exact-Capitalization settings defined on the Capitalization Editor (<Ctrl+S>), if Anti-Cap and/or Exact-Cap, below, are enabled. Auto-capitalization is not applied to multi-line tag fields (see "Multi-line Fields" in topic "Apply to..."), but all other auto-edit options are applied.

All Upper: All file names are created in all uppercase letters.

All Lower: All file names are created in all lowercase letters.

As Is: Create names from tag data as the data appears in the tags, with no capitalization changes made.

Note that the capitalization of file extensions is under separate control (see Extension Capitalization below).

The capitalization setting you choose here can be used in another way. If you clear the Selected Template box and leave it blank, clicking the Preview Button applies the selected capitalization setting directly to the contents of the Preview Window. That is, new filenames are not constructed from tag data, but instead existing names are capitalized in accordance with capitalization setting specified here.

Options:

Remove 'The ' When the word "the" (followed by a space) is found at the beginning of text in an artist-type field*, it is automatically removed. Thus, for example, when this option is active, a file with "The Kingston Trio" as artist and "Five Hundred Miles" as title will be renamed to "Kingston Trio - Five Hundred Miles," rather than "The Kingston Trio - File Hundred Miles."

*Artist, Original Artist, Orchestra/Band, Album Artist, Sort Artist, or Sort Album Artist

'& xxx' -> 'and xxx' When the expressions " & his ", " & the ", or " & a " are found anywhere in a tag field, convert them to " and his", " and the ", and " and a ", respectively, during a rename or rename preview.

'X -> 'x: Whenever one of the characters D, M, S, or T (followed by a space or at end-of-text) is found to occur after an apostrophe, or one of the characters L, R, or V is found to occur after an apostrophe, convert the letter to lower case. Thus, for example, the contraction "can't" is capitalized as "Can't" and not "Can'T," when this option is enabled. Note that this option takes precedence over the more general option to auto-cap after all apostrophes found in "Default Capitalization Options" on the Capitalization Editor.

'Xx -> 'xx: Whenever one of the letter sequences VE, LL, or RE (followed by a space or at end-of-text) is found to occur after an apostrophe, convert it to lower case. Thus, for example, the contraction "we've" is capitalized as "We've" rather than "We'Ve," when this option is enabled. Note that this option takes precedence over the more general option to auto-cap after all apostrophes found in "Default Capitalization Options" on the Capitalization Editor.

'Mcx -> McX' Capitalize the next letter following the expression "Mc". Thus, for example, the name "mcguire" is capitalized as "McGuire" rather than "Mcguire."

" -> ' Convert double-quotes to single-quotes.

'_' -> ' ' Convert underbars to spaces.

Anti-Cap: Prevent capitalization of all words and phrases in the anti-capitalization list on the Capitalization Editor (click small button [image] for access). When Auto-Cap (see above) is applied to a tag field, the words and phrases on the anti-cap list are prevented from being capitalized. May also be enabled or disabled with the "Enable Anti-Cap List' checkbox on the Capitalization Editor itself.

Exact-Cap: Capitalize all words and phrases in the exact-capitalization list as shown on the Capitalization Editor (click small button [image] to access this editor). When Auto-Cap (see above) is applied to a tag field, words and phrases in the exact-cap list are capitalized exactly as shown in the list. May also be enabled or disabled with the "Enable Exact-Cap List' checkbox on the Capitalization Editor itself.

Note: The options above are applied in the order listed.

Auto-Edit Paths: Apply all enabled auto-edit options above to the path portion of a fully-qualified new filename, when renaming involves Directory Restructuring. When disabled, only the file name portion of a new name is auto-edited.

Do partial-data renames: When a file to be renamed contains no data in one or more (but not all) tag fields used to create a new name, the file appears in a preview with the expression ***PARTIAL DATA*** prepended to its proposed new name. By default such files are skipped during the renaming process and are not renamed. This option may be enabled to have such files renamed anyway, using whatever tag data happens to be present. This setting is not applicable when the rename template being applied contains a backslash character "\," indicating Directory Restructuring is to be performed (that is, files are to be moved as well as renamed). Partial-data renames are not permitted when restructuring; although, partials can be manually edited and corrected via the Preview Window's popup menu "Edit" function. Note that if a file contains no data in ANY tag fields used to create a new name, the file's name appears in a preview with the flag ***NO DATA*** in front of it. Files with this designation will not be renamed unless manually corrected first.

Use two digit track: Insert a leading zero in front of any single-digit track number when the track is used as part of a new file name. Options is also applied to Episode numbers and Season numbers if used in a name.

Stop on illegals: The OS does not allow certain text characters ( \ , / , : , * , ? , " , < , > , and | ) to be used as part of a filename. When a file to be renamed contains one or more of these characters in the tag data being used to rename it, the proposed new name appears in the Preview Window with the expression "***ILLEGAL DATA***" added in front of the name. When enabled,

1) If using the Rename Page, the Rename button is turned red when a rename preview produces a new name containing an illegal character. File renaming is not allowed to proceed. When disabled, new names containing illegal characters are automatically skipped during the renaming process, the Rename button is turned yellow, and a summary is given at the end indicating how many skips occurred.

2) If using a popup menu's Rename function (see Renaming with the Popup Menu below), notification is given as each instance of a defect is found, and an opportunity is given to cancel or proceed with the renaming process. When disabled, file names containing illegal characters are simply skipped, with a summary of skipped files given at the end of the renaming process.

Auto-replace illegals: Optionally remove or replace illegal characters in tag text used for renaming, as directed on the Illegal Character Replacement Editor (click button [image] to execute this editor). This option is ignored if Stop on illegals, above, is enabled.

Note that changes made to these options are not recorded by the program's undo facilities (with the exception of the Anti-Cap and Exact-Cap settings). Thus, if they are changed between Previews, precise undo's cannot be guaranteed.

When renaming files using the contents of the Comment or User Text fields as part of the name, line breaks are removed and lines are concatenated to form new names. See topic Comment Editor for additional discussion about multi-line tag data in Library Clinic.

Substitution: Mass-replaces text entered in the Replace Box with text entered in the With Box. Previewed file names are searched for the "Replace" text and, when found, replaced with the "With" text.

Clear: Removes all text from both the Replace Box and the With Box.

Replace: Enter text in this box to be replaced or deleted in previewed file names.

With: Enter text to be substituted for text entered in the Replace text box. Leave box empty to have the Replace text simply removed rather than replaced.

Preview: Previews proposed file name changes in the Preview Window. Checkboxes are provided for including or excluding specific files from the rename process. Individual names may be manually edited by choosing "Edit" from a popup menu or double-clicking a row. The Preview button appears with an underlined "R" [image] when a Selected Template rename is to be previewed, and an underlined "S" [image] when a Substitution preview is to be performed. Switch between preview types using the mouse: click a Substitution control to activate substitution previews; click any other control to activate renaming via template.

Back: Discards the current preview and returns to the previous one.

Rename: When enabled, renames files to the previewed file names as shown in the Preview Window.

Check for Duplicates: Although new file names are checked for uniqueness dynamically as files are renamed, this feature can be used to check for duplicates beforehand, thus avoiding warning messages and skipped files that duplicates otherwise produce. Duplicate file names can occur because two or more tags can contain the same data in the tag fields used to create their file names. When duplicates are found, the number of names that occur more than once, as well as the total number of duplicates, are reported, and the duplicates themselves are highlighted in the Preview Window. You can save the list of duplicates to a text file or view it as a printable report.

Reset: Discards all queued previews and reloads the Preview Window with current filenames.

Renaming with the Popup Menu

When one or more rows are selected in the Main Editor, a popup menu is produced when the mouse is right-clicked on an Editor column:

Choose option Rename on this popup to be presented with a submenu containing the list of naming templates already defined on the Rename Page (see above). Choosing a template initiates a rename of all selected files to the chosen template format, using data from each file's tag to form the name. Renaming is performed in the same manner as is done on the Rename Page itself.

All auto-edit options in effect on the Rename Page are applied when renaming via popup menu, including capitalization and all applicable option settings. By default, a rename preview is produced on a separate form before renaming occurs allowing confirmation before proceeding. Checkboxes are provided for including or excluding specific files from the rename process. As with Rename Page previews, you can edit individual names before renaming by right-clicking a specific name and choosing "Edit" from a context popup menu. Previews are optional, however. To bypass future previews and begin renaming immediately as soon as a template is chosen, check the "Skip previews" box at the bottom of any preview. Turn previews back on again in the Behavior section of Preferences. Once a rename process has begun, you can terminate or pause it by clicking anywhere on the Editor.


Capitalization Editor

Access: Menu > Edit > Capitalization Editor, <Ctrl+S>, [image] Toolbar button

The Capitalization Editor contains two separate-but-similar capitalization editors useful for creating your own custom capitalization rules. They can be applied to file name and/or tag field edits, when the program auto-capitalizes on its own, or when you manually instruct it to do so by choosing "Cap Rules" from a Main Editor popup menu.

Anti-Capitalization Editor:

Use the Anti-Cap Editor to inform the program of particular words and/or phrases that you would NOT like to have capitalized when a file is renamed or a tag field is edited. The Active List on the right holds words and phrases that are not to be capitalized. The Inactive List on the left can hold items that are currently being allowed to be capitalized, but are being kept available in case they need to be returned to "active duty." The Editor contains a brief, default list of common articles, conjunctions, and short prepositions that are kept present in the Editor at all times and cannot be removed. Any or all of them, however, including default items, can be transferred from the Active List into the Inactive List, or vice versa, by using the left-right arrow buttons.

Add your own items to the list by typing them into the edit box and clicking the Add button or pressing the Enter key. Custom items created can be removed by highlighting one or more in a list and pressing the Delete button. Use the Highlight Custom Entries button to help identify items you have added to the list yourself. Button Load Default Items clears both lists and reloads the Active List with default items.

Check the Enable Anti-Cap checkbox to have the Active List enabled in the system and to have the list applied to future renames and tag edits. The Anti-Capitalization List can also be enabled or disabled using the "Anti-Cap" checkbox on the Options Panel. When Anti-Cap is active, a minus sign (-) appears appended to the capital "A" on the Auto-Capitalize enable/disable button on the Top Toolbar B (a plus-or-minus sign "±" will appear instead, if the Exact-Capitalization List, described below, is also active). You can click this button to cycle Anti-Cap between on and off. Note that listed items must be "embedded" in text to have anti-capitalization applied: single words qualify if they have a space on each side, while phrases must be found with a space on the left.

Exact-Capitalization Editor:

The Exact-Capitalization Editor lists words and phrases you would like to have capitalized EXACTLY as they appear in the list (spaces are shown as caret symbols). The Active List on the right holds items that are to be capitalized as shown, while the Inactive List on the left can hold any items you don't want acted upon now but want to keep available for return to the Active List if needed. Any or all items can be transferred from the Active List to the Inactive List, or vice versa, by using the left-right arrow buttons.

Add your own items to the list by typing them into the edit box and clicking the Add button, or by pressing the Enter key. Custom items created can be removed by highlighting one or more, then pressing the Delete button.

Check the Enable Exact-Cap checkbox to have the Active List enabled in the system and have it applied to future renames and tag edits. The Exact-Capitalization List can also be enabled or disabled with the "Exact-Cap" checkbox on the Options Panel. When Exact-Cap is active, a plus sign (+) appears appended to the capital "A" on the Auto-Capitalize enable/disable button on the Top Toolbar B (a plus-or-minus sign "±" will appear instead if the Anti-Capitalization List, described above, is also active). You can click this button to cycle Exact-Cap between on and off.

Enable Auto-Cap:

Automatically capitalize all words in a filename or cell text after an editing event changes it's content. When Auto-Cap is enabled, the Auto-Capitalize enable/disable button on Top Toolbar B shows a capital "A" [image]. When disabled, the button shows a small letter "a" [image] (a plus, minus, or plus-or-minus may be appended, depending upon whether Anti-Cap and/or Exact-Cap are also active - see below). The Auto-Capitalize button can be clicked to cycle Auto-Cap between on and off.

Only apply when Auto-Cap is enabled:

Modifies which capitalization options are presented on the Auto-Capitalize button (Top Toolbar B) as it is clicked through available options. Capitalization features are applied in the Editor in accordance with the status of this option, as well as whether Anti-Capitalization and Exact-Capitalization (above) are enabled:

Anti-Cap and Exact-Cap are both enabled -

no cap options applied

Anti-Cap and Exact-Cap are applied*

Auto-Cap, Anti-Cap, then Exact-Cap are applied

Only Anti-Cap is enabled -

no cap options applied

Anti-Cap is applied*

Auto-Cap then Anti-Cap are applied

Only Exact-Cap is enabled -

no cap options applied

Exact-Cap is applied*

Auto-Cap then Exact-Cap are applied

*available only when "Only apply when Auto-Cap is enabled" is not checked

Default Capitalization Options [image]:

The capitalization function used to perform routine capitalizations can be adjusted to capitalize or not capitalize the first letter after specific symbols or characters, in accordance with your preferences:

Check the box to the left of a listed item to have the first letter that appears after it capitalized, whenever auto-capitalization is performed by the program.

Note that capitalization rules are generally performed in the following order: First the Default Capitalization Options above are applied, then any auto-edit capitalization options that are enabled on the Options Panel or Rename Page, whichever is applicable, then the Anti-Capitalization rules, and finally the Exact-Capitalization rules are applied.


Column Order and Visibility

Access: Menu > File > Column properties, <Ctrl+M>, [image] Top Toolbar B button

Use the Column Properties Panel to adjust which data columns are visible and in what order they appear in the Editor. Columns shown in blue have corresponding data fields in the iTunes library file. Those in black are supported only in file tags, or are file information fields.

Controls:

Two sets of Plus/Minus buttons adjust Height and Width of the panel.

Check or uncheck a particular listing to make the corresponding column visible or invisible in the Editor.

Select an item in the list, then click the Up/Down arrow keys on the right to move its position left or right in the Editor.

Enables or disables a horizontal scroll bar for the list.

Show:

Standard: Make standard columns (Title, Artist, Album, Comment, Year, Genre, Track, etc) visible while hiding the rest.

iTunes-All: Makes all valid iTunes columns visible. Hides columns only applicable to the Tag View.

All: Makes all columns visible. Enabled in iTunes Mode only when the iTunes view is linking to tags . Does not include iTunes-only columns when in Tags Mode.

Toggle:

All: Alternately makes all columns visible then not visible. In iTunes Mode, does not include columns that are only supported in tags unless the iTunes view is linking to tags . In Tags Mode does not include columns that are only supported in iTunes.

iTunes-All: Makes all valid columns alternately visible then not visible. Enabled only in iTunes Mode.

Misc: Toggles various columns (Miscellaneous through URLs, excluding Originals) on and off as a group. Not enabled in iTunes Mode unless the iTunes view is linking to tags.

Orig: Toggles "Originals" columns (Original Artist, Album, Filename, Lyricist, and Year) on and off as a group. Not enabled in iTunes Mode unless the iTunes view is linking to tags.

MM: Toggles MusicMatch columns on/off as a group: MusicMatch Tempo through MusicMatch Arranger. Not enabled in iTunes Mode unless the iTunes view is linking to tags.

Save: Saves current columns properties to one of three backup copies, for a later recall using the Recall button (below).

Recall: Recalls a column configuration previously saved with the "Save" button (above).

Default Settings: Resets Editor columns to default visibility, order, and width properties.

Column Popup Menu:

Columns can be hidden, swapped right or left, or have their width reset to a default value by using a context menu available via right-click on a header row cell, or by applying an associated shortcut sequence:

The Hide, Swap and Reset Width functions can also be initiated via shortcut keys.

Hide: <Alt + Down Arrow>

Swap right: <Alt + Rigth Arrow>

Swap left: <Alt + Left Arrow>

Reset width: <Alt + Up Arrow>

Before using a shortcut, set the column you want to operate on by clicking into one of its column cells (most non-editable columns can be set by right-clicking a cell).

Column Drag-and-Drop:

Most columns in the Editor can also be moved to another location via drag-and-drop: while holding the Control Key depressed, drag a column header cell button onto another column to have the dragged column inserted there. In the image below, the Artist column is being dragged to the Title column position. If released there, the Title column will move to the right and the Artist column will take its place.


Comment Editor

Access: Click comment column cell button, or double-click a comment cell (depending upon Preferences setting)

The MP3's ID3v2 tag, as well as some other tag types, allows for multiple lines of text to exist in a comment field. Library Clinic supports multi-line text fields in two ways:

1) Comment and other multi-line fields are shown in the Editor as one line of text with line breaks replaced by caret (^) symbols. When a tag is updated, carets are replaced with newline character codes (hex '0D0A' for tags, hex '0A' for iTunes). Remove a line break by removing a caret. To add one, type in a caret anywhere you would like a new line to begin.

2) Often a multi-line field is too long to view or edit comfortably on the single line shown in the Editor. To edit or view long text entries, or to work with multiple comments, click the "ellipse button" [image] that appears on the right in a cell when it's selected. This executes a stand-alone subeditor, as shown below for the Comment field (subeditors may also be set to execute by double-clicking on a cell - see topic Preferences).

Two copies of the comment field's contents are shown. The copy on the left is an optional read-only copy for use as a reference and copy source (to expose, see "View > Original Text" on the Menu bar). The copy on the right may be edited and becomes the new tag contents when the OK button is clicked, or when you move to another tag. Resize the editor by dragging a corner of the window with the mouse. The center partition is adjustable by dragging it to one side or the other. Depressing the Reset button returns the editor to its default size.

Optional data fields:

1) Description: A brief description or summary describing the overall content or purpose of the comment. This information is optional and is stored as a separate subfield within the comment frame. NOTE: Because some programs (such as iTunes) use comment fields to store normalization and other data, and because a unique identifier is placed in the description field to identify them, many tag readers are now designed to skip over and not show comments that have text in their description subfield. Use of this field is therefore not recommended.

2) Language: From this drop down list, select the language that the tag is written in. Like the description data above, this information is stored as a separate field within the comment frame.

Three conditions determine which language appears in the language field when the Comment Editor is executed:

* If there is already a comment field present in the tag and it contains a recognized language descriptor, the language associated with the descriptor appears.

* If there is already a comment field present in the tag but it contains an unrecognized language descriptor, the selection "Undetermined" appears.

* If there is no comment field present in the tag, it is assumed that a new comment is being added, and the Default Language specified in Preferences is shown.

When renaming files using the ID3v2 comment field as part of the name, line breaks are removed and lines concatenated to form a new name. Similarly, if V1 syncs with V2 is enabled on the Options Panel, line breaks are replaced with space characters in multi-line ID3v2 comments before being written to ID3v1 comment fields. Since the ID3v1 comment field can hold only a maximum of 28 characters, however, only the first 28 characters are written. When synchronizing, you can choose to have the ID3v1 comment field display either 1) the full text it receives from ID3v2, regardless of length (Trim Overlength disabled), or 2) the text that will actually be written to the tag (Trim Overlength enabled). Tag types other than MP3 will accommodate any length of text in a comment field.

When a change is made to an ID3v1 Comment while V2 syncs with V1 is enabled, the entire contents of the ID3v2 Comment field is replaced with the single-line ID3v1 comment text.

When saving comments to multiple files with the PasteDown Panel, any carets in the comment field are interpreted as newline characters and the content is saved as a multi-line comment, if the tag type allows. When saving to ID3v1 tags, carets are replaced with space characters before being written.

Multiple Comments -

The Comment Editor supports the existence of multiple comments in a single tag. Tags that contain more than one comment are flagged in the Editor by a small red triangle appearing in the upper right corner of a cell [image] (as are other cells that support multiple instances). Briefly holding the mouse pointer over a cell containing this indicator will produce a small "hint" giving the number of comments contained in the tag.

Use the Comment Editor's Add button to insert additional comments into a tag, or the Delete button to remove one. New comments created have their Language setting automatically set to the Default Language specified in Preferences' Tag Options section.

When multiple comments are present in a tag, only the first one in the tag is operated on by tag synchronizations, column data swaps, and most other kinds of multi-file operations. For example, if ID3v2 tags are set to synchronize with ID3v1 when an ID3v1 comment is deleted, only the first ID3v2 comment in the corresponding ID3v2 tag is deleted as a result of synchronization. If a second comment exists in the tag, it will take the place of the first one in the Editor.

iTune Comments -

iTunes stores its audio normalization and equalization data for MP3s in custom ID3v2 comment frames identifiable by a comment description field with text "iTunNORM." These frames contain hexadecimal text data and is not normally edited manually, nor would one normally want to view it. By default, Library Clinic skips over these frames whenever displaying or processing MP3 comments so that they become, in effect, transparent to the user. Tag operations that remove entire tags will remove these frames, but other operations look for them and bypass them when found.

You can manually remove iTune frames from all files, or from just selected files, by choosing Main Menu > ID3v2 > Remove iTune comment frames <Alt + F11>. If desired, you can disable Library Clinic's default handling of iTunes frames by manually editing the Initialization File to allow them to be displayed and processed just like other types of MP3 comment frames. In your install folder, look for file "LibraryClinic.ini." With a text editor, edit the statement "ShowITune=0" in section "[MiscSettings]" in this file, so that it reads "ShowITune=1".


Converters

Convert ID3v2.2 to ID3v2.3

Access: Menu > MP3 > Convert ID3v2.2 to ID3v2.3, <Alt+F6>, Speedbutton Toolbar button

Converts the ID3v2 tags in all or just selected files from tag version ID3v2.2 to tag version ID3v2.3. If specific files (rows) are selected in the Editor, only selected files are converted. If no files are selected, it is assumed that all files are to be operated upon.

Convert ID3v2.3 to ID3v2.4

Access: Menu > MP3 > Convert ID3v2.3 to ID3v2.4, <Alt+F7>, Speedbutton Toolbar button

Convert the ID3v2.3 tags in all or just selected files from tag version ID3v2.3 to tag version ID3v2.4. If specific files (rows) are selected in the Main Editor, only those selected are converted. If no files are selected, it is assumed that all v2.3 files are to be converted.

Tags at version ID3v2.4 are unsynchronized on a frame by frame basis, as needed, whereas all frames in ID3v2.3 tags have unsynchronization applied (see heading Unsynchronization in topic Preferences for further information about Unsynchronization). Only tags at version ID3v2.4 support the "Musicians Credits" list (shown in Editor 2 in column "Musicians"), where tags at version ID3v2.3 do not. Be aware also that, as of the time of this writing, few tag editors and other applications that edit or use ID3v2 tags support the newer ID3v2.4 tag standard. Thus, tags converted to this standard will not be usable in some programs.

Convert ID3v2.4 to ID3v2.3

Access: Menu > MP3 > Convert ID3v2.4 to ID3v2.3, <Alt+F8>, Speedbutton Toolbar button

Converts the ID3v2.3 tags in all or just selected files from tag version ID3v2.4 to tag version ID3v2.3. If specific files (rows) are selected in the Editor, then only those files are converted. If no files are selected, it is assumed that all v2.4 files are to be converted.

See heading Convert ID3v2.3 to ID3v2.4 above for important information about some of the differences between these two ID3v2 tag versions.

Convert ASCII tags to Unicode

Access: Menu > MP3 > Convert ASCII tags to Unicode, <Alt+F9>, Speedbutton Toolbar button

Converts tag data in all or just selected ID3v2 tags from plain ASCII text to Unicode-encoded data (UTF-16). If specific files (rows) are selected in the Main Editor, then only those files are converted. If no files are selected, it is assumed that all ID3v2 are to be converted.

Convert Unicode tags to ASCII

Access: Menu > MP3 > Convert Unicode tags to ASCII, <Alt+F10>, Speedbutton Toolbar button

Converts tag text in all or just selected ID3v2 tags from Unicode-encoded data (UTF-16, UTF-16BE, or UTF-8) to plain ASCII text. If specific files (rows) are selected in the Editor, then only those selected files are converted. If no files are selected, it is assumed that all applicable files are to be converted.

Rating to MusicMatch Rating

Access: Menu > MP3 > Rating to MusicMatch Rating, <Ctrl+Alt+5>

Converts MP3 Popularimeter ratings (range 1-255) and/or M4A/MP4 ratings (range 1-100) into MusicMatch ratings (range 1-5), and stores them in the MusicMatch Rating field (column heading "MM Rating"). All ratings are shown in the Editor as one- to five-star ratings ("*" to "* * * * *"). Number ranges refer to the values stored internally in specific tag types to represent these ratings. Operates on all or just selected files.

Some background information about ratings:

In MP3's, rating information is stored in one of three sub-fields enclosed by the ID3v2 Popularimeter frame (which also houses an email address and a playcount). Program MusicMatch creates a rating frame from an ordinary Comment frame, giving it a unique description field ("MusicMatch_Preference") so that it can be distinguished from other Comment frames. In M4A's and MP4's, Apple has pre-defined a rating frame with an atom identifier of "rtng," and this is where Tag Clinic stores rating information for these file types. Tunes does not store its own rating information there, however, but instead stores it in its library file. Program Tag & Rename defines its own rating atom for M4A's and MP4's, which it identifies as "rati," and Tag Clinic will look for a rating in this field if it can't find one in the iTunes "rtng" field. In addition, when storing a rating, it will copy a rating it puts in "rtng" into the "rtng" field also.

MusicMatch Rating to Rating

Access: Menu > MP3 > MusicMatch Rating to Rating, <Ctrl+Alt+6>

Converts MusicMatch ratings (range 1-5) in MP3,M4A, and/or MP4s (column heading "MM Rating") into MP3 Popularimeter ratings (range 1-255) or M4A/MP4 ratings (range 1-100), and stores them in the Rating field (column heading "Rating"). All ratings are shown in the Editor as one- to five-star ratings. Number ranges refer to the values stored internally in specific tag types to represent these ratings. Operates on all or just selected files.


Encapsulated Objects Editor

Access: Click any cell in the Editor's Obj column

The Encapsulated Objects Editor allows storage of any type "object" inside an ID3v2 tag. Store virtually any type of file, from simple text files, to movies, to executables - even other MP3s.

To determine if a tag already contains encapsulated objects, examine the "Obj" column in the Editor. If one or more objects have been detected within a tag, the column contains a number representing the number of objects found. For access to a tag's objects, or to add, remove, edit, or open objects, click on a cell in this column to execute the Encapsulated Objects Editor.

The Objects Editor provides the options to:

Clear the object table and reload it from existing tag data.

Restore the Editor to its default proportions.

Clear the list of all objects.

Save an object to an external file on your hard drive.

Open an object with the program on your system that's associated with its file type.

Remove an object from a tag

Navigate the editor to the previous file/tag.

Navigate the editor the next file/tag.

Add one or more objects selected in the Browser File Window, top right, to the object list/table.

Adding Objects -

Browse to the file or files you want to add using the file Browser in the upper section. To add a single object, double-click its file name, click the Add button after highlighting the name, or use the popup menu. Add multiple files by highlighting multiple files, then clicking the Add button. The file name itself is the only required field for an object. However, if multiple objects are to be stored in a tag, each object must have a unique Description.

An internal list of over 500 MIME types is searched for each object added. If an object's file extension matches a listed MIME type, the type is entered automatically in the MIME Type column. If a match is not found, the default MIME type of "application/octet-stream" is entered. The MIME type is not a required field, and can be removed from an object by selecting "None" from the drop down list of MIME types. If a listed object is already in the tag, the Location column contains the word "tag." If it has not yet been added to the tag, it contains the location of the object on your hard drive. New objects are not added until the OK, Up, or Down button is pressed.

To open an object, double-click its file name in the Object List (lower section). The object is sent to Windows with a request to open it in whatever program happens to be associated with that type of file on your system.

Note that you can cut, copy, paste, or delete objects from tags using the Editor 's popup menus in the same way as ordinary text. The Single-Tag Popup's "Delete" removes one object per execution (the first one found in a tag), while the Multi-Tag Popup's "Delete" removes all objects at one time.


Illegal Character Editor

Access: Menu > Edit > Illegal Character Editor, <F10>, [image] toolbar button, [image] Options Panel edit button

Some text characters are not allowed by Windows to be used in a file name:

\ / : * ? " < > |

The presence of one or more of these characters in tag text used to rename a file will prevent the file from being renamed. The Illegal Character Editor can be used to tell the program in advance that you would like to automatically replace or remove specific illegal characters found, before the text is used to rename a file.

In the edit box below each of the nine illegal characters, type-in text to be used as a replacement (up to 3 characters max) when the program encounters the corresponding character in tag text it will use to auto-rename a file. To have an illegal character simply removed, enter a single asterisk (*) in the edit box instead. "Space" characters entered here appear in the editor as caret symbols (^) for clarity. In the example shown in the editor above, "backslashes" are to be replaced by a hyphen with a space on each side, while "question marks" are to be removed.

To enable illegal character replacement during renaming, check the "Enable illegal character replacement" checkbox. The status of this box is mirrored by the "Auto-replace illegals" checkbox on the Options Panel's Rename Tab (<Ctrl+O>), which can also be used to enable or disable the option.


List Editors

Itunes Playlist Editor

Access: Menu > Itunes > Edit playlists, <Ctrl+Alt+7>, [image] Toolbar A button

Use the Playlist Editor to add, remove, or edit iTunes playlists.

Use the popup menu on the playlist column or on selected files in the file list to access the following editing functions. Rows are selected in this list in the same manner as in the main editor, by clicking or dragging the mouse on the row number column.

Playlist Popup -

Add files: Brings up a list of files currently found in the main editor. Select applicable rows on this list and click the "Add" button.

Paste files: Installs files that have been copied via the File List Popup menu into the selected playlist.

Remove list: Removes the selected playlist from the library.

Rename list: Allows edit of an existing playlist's name.

New list: Adds a new playlist to the library.

Remove empties: Removes playlists from the library that contain no files.

Import M3U playlist: Add to iTunes playlist the file names listed in an .m3u playlist file. M3U file must be an absolute playlist (i.e., file names must contain paths). Only files already listed in the Editor can be added.

File List Popup -

Remove: Removes selected files from their respective playlists. Will remove the playlist itself if no files remain in it.

Cut: Prepares selected files for removal from their current location so they can be pasted into another list via the "Paste files" function above.

Copy: Prepares selected files for paste into another list via the "Paste files" function above.

Options -

Remove empty lists on load: Check this option to have playlists that contain no files automatically removed as the Playlist Editor is initially loaded with files.

Remove duplicate lists on load: Check to have second and subsequent same-name playlists automatically removed as the Playlist Editor is loaded with files.

Undo: Discard all changes made to playlists and reload the Playlist Editor.

Add List: Creates a new playlist and adds it to the list.

Save and Exit: Commit all changes made and return to main editor.

Cancel: Discard all changes made and return to main editor.

Note that iTunes can have qualifications for list entries in its standard lists that are not enforced by this Editor. For example, an acceptable file for the "TV Shows" category in iTunes requires that a file be a video file with entries in the Show, Season, Episode ID, Episode Number, and TV Network fields, and with a genre of "TV Shows" and a "Stik" column entry of "TV Show."

ID3v1 Genres List Editor

Access: Menu > Edit > ID3v1 Genres Editor, <Ctrl+G>, [image] Speedbuton Toolbar button

148 default genres have been defined by the technical specification for ID3v1 tags. Use the ID3v1 Genre List Editor to remove seldom-used or unwanted genres from the drop-down list presented when an ID3v1 genre cell is selected in the Editor.

Click the left-arrow button to remove selected genres from the Genre List on the right and place them into the Unused Genres list on the left. Genres in the Unused Genres are not presented in the ID3v1 drop-down genre list. Likewise, click the right-arrow button to move selected genres in the Unused Genres list back into the Genre List to allow access from the drop-down list. The double right-arrow button moves all genres in the Unused Genres list back into the Genres List.

Things to keep in mind about ID3v1 genre behavior in Library Clinic:

* Library Clinic displays whatever genre it finds in an ID3v1 genre field, regardless of whether the genre is in its list of active genres or not. However, genres that have been removed from the active Genre List and moved into the Unused Genres List cannot be copied or pasted into ID3v1 genre cells in the Editor. The PasteDown Panel can be used at any time, however, to write any ID3v1 genre into either one or multiple files, regardless of whether the genre being written is in the active Genre List or not.

* ID3v1 genres not in the active Genre List cannot be removed from a tag by choosing the "None" selection at the top of the drop down genre list presented in ID3v1 genre cells. However, they can be removed by selecting them and pressing the Delete key. Or, they can first be changed to a listed genre type before being removed using "None" in the list.

ID3v2 Genres List Editor

Access: Menu > Edit > ID3v2 Genres Editor, <Ctrl+H>, [image] Speedbuton Toolbar button

The ID3v2 Genre Editor makes it possible to add your own custom-made genres to the drop-down list of genres that appears in each genre cell in Main Editor page 2 when a genre cell is selected (if option Drop-List is selected in Preferences). The Genre List can hold a maximum of 256 entries.

By default, the list is first loaded with the standard set of 148 genre types (plus "None," which can be used to remove a genre in a genre cell). This list is inherited from the older ID3v1 Technical Specification. To add a new genre, enter a genre name into the text box beneath "Enter genre" and click the Add button. To remove one, enter the genre name to delete (or click its name in the Genre List), then click the Delete button. Select multiple genres for removal by first clicking the mouse one genre in the list, then dragging the mouse down across subsequent genres to be removed, and/or by holding the Control key depressed while left-clicking additional genres. Or, select multiple consecutive genres by clicking the first one, then while holding the Shift key depressed, clicking the last.

Options -

Highlight Custom Genres: Highlights all genres in the list that are not found in the standard list of ID3v1 genre types.

Highlight Default Genres: Highlights all genres in the Genre List that are not found in the standard list of 148 ID3v1 genre types.

Save Copy 1/Save Copy 2: Saves the current Genre List as a recallable copy in a separate archive. Copies can be reloaded at any time by hitting the respective Recall button described below

Reset: Clears the entire list and reloads it with the standard, default list of 148 ID3v1 genres.

Recall Copy 1/Recall Copy 2: Deletes the current list and replaces it with a list that has been archived with a Save buttons, described above.

Note that non-default genres can be added only to the ID3v2 list; they cannot be added to the ID3v1 list. The older ID3v1 tag, unlike the ID3v2, does not actually store the genre itself as a "text value," but instead stores a predefined reference number that has been associated with a particular genre by the technical specification for this tag type. These associations cannot be altered without losing compatibility with other programs that read them. Only the default list of 148 predefined genre types is routinely recognized by most ID3v1 tag readers. New genres can be added to the ID3v2 list, however, because this tag can use both predefined ID3v1 genre reference numbers as well as actual text values that have not been previously defined by a particular technical specification.

Things to keep in mind about ID3v2 genre behavior in Library Clinic:

* When an attempt is made to copy a user-defined, non-default genre from ID3v2 into ID3v1, either intentionally or because the tags have been set to synchronize, the corresponding ID3v1 genre field is simply erased, regardless of whether it already contains a valid ID3v1 genre or not.

* Genres entered in the Editor that are listed in the ID3v1 standard genre list are automatically capitalized as found in the standard list, regardless of how they are entered into the ID3v2 editor.

* The VQF Technical Specification does not include a pre-defined genre tag field. However, the Spec for this tag does allow for the creation of custom, user-defined tag fields, and a genre field is implemented in this way for VQFs in this program. Bear in mind that most VQF tag readers do not look for nor read a genre field, so genres installed in VQF tags by Library Clinic will likely not be readable elsewhere.

Artist, Composer, Conductor, Orchestra/Band/Album Artist , and Encoder Settings List Editors

Access: Menu > Edit > Composer Editor, <Ctrl+Alt+U>, [image] Speedbuton Toolbar button

These editors allow customization of drop-down lists appearing in corresponding columns in the Editor. The Composer Editor is shown as a typical example below. Others are quite similar. When a cell in one of these columns is selected, a drop-down list of possible values appears in the cell from which a listed entry can be chosen. Each column that implements one of these lists has an individual checkbox in Preferences which enables access to the list in the Editor when the respective cell type is entered. Most of the controls appearing on these editors, along with their functions, are similar to those described above for the Genre Editor.

Highlighting an entry places it in the edit box. You can edit the item then click the Update button to replace the original, or create a new item and click the Add button to have it added to the list. Each editor comes with a default list can be loaded with the Reset button. You can overwrite the default list with the list currently in view by using the Save As Default List button. The current list is automatically saved as the active list when the OK button is clicked. You can create an alternate list for recall later with the Save Copy button.

Copy and default lists for these editors are simple Unicode text files with one entry per line. They can be edited manually with a text editor if desired.


Lyrics Editor

Lyric Editor

Access: Click lyrics column cell button, or double-click the cell (depending upon Preferences setting)

Unsynchronized Lyrics

Unsynchronized Lyrics are shown in the Main Editor's Lyric's Column as one line of text, with line breaks replaced by caret (^) symbols. Before a multi-line lyric is saved to a file, each caret is replaced with a newline character code sequence (hex '0D0A'). A line break can be inserted in Lyrics text in the main Editor cell just by typing-in a caret symbol anywhere you would like a new line to begin. Likewise, you can remove a line break by removing a caret from a cell.

Of course, most lyric text is too lengthy to edit or view comfortably in the single-line data cell provided in the Main Editor. Access a stand-alone Lyrics Editor by either double-clicking a lyrics cell, or by clicking a small "ellipse" button that appears on the right side inside the cell when it's selected (depending upon the Subeditor Access Method specified in Preferences):

This brings up the field's contents in a stand-alone editor:

Two copies of the Lyrics text field's current contents are shown. The copy on the left is an optional read-only copy of the Unsynchronized Lyrics for use as a reference and copy source, while the one on the right is editable and will become the new contents when the "OK" button is depressed, or when you move to another tag. To expose the original copy check "View > Original Lyrics" on the Menu bar. Resize the editor by dragging a corner of the window with the mouse or by clicking the "Arrow" keys on the bottom left. Click on the "Reset" button to return the editor to its default size and proportions. The Undo button [image] re-reads the entire tag and reloads the Editor; it does not undo the last edit operation.

Optional data fields

1) Lyricist: The name of the author of the lyrics. The Lyricist field is a separate tag field distinct from the Lyrics field itself and is stored in its own frame within the tag. This field is a mirror of Lyricist column. Changing the content in on location changes it in both.

2) Original Lyricist: The name of the original author of the lyrics. Like the Lyricist field above, this field is a separate tag field distinct from the Lyrics field, is stored separately in the tag, and is only shown here for convenience. This field is a of the Original Lyricist column. Changing the content in on location changes it in both.

3) Description: Enter a brief description or summary describing the lyrics. This information is stored as part of the Lyrics field itself and is automatically cleared if the Lyrics Editor is exited with no lyrics present.

4) Language: From this drop down list, select the language that the lyrics are written in.

Three conditions determine which language appears in this field when the Editor is executed:

  • If there is already a lyrics frame present in the tag, and it contains a recognized language descriptor, the language found appears.

  • If there is already a lyrics frame present in the tag, but it contains an unrecognized language descriptor, the selection "Undetermined" appears.

  • If there is no lyrics frame present in the tag, it is assumed that a new one is being created, and the Default Language specified in Preferences is presented.

Like the Description, the Language is stored as part of the Lyrics field itself and is automatically cleared if the Lyrics Editor is exited with no lyrics present.

The Description field is cleared, and the Language reset to the Default Language, if the lyric's contents are altered by any process other than a direct edit of the individual lyrics cell. Thus, for example, if data are swapped between the lyrics column and another column, any text in the Description field is discarded and the Language is set to the Default Language specified in Preferences. The Lyricist and Original Lyricist fields are left untouched, since technically they are separate tag frames and not part of the Lyrics frame itself.

Not all lyrics fields are supported in all tags. Those not supported are "grayed out" and/or disabled when not applicable to the tag being edited.

Main Menu "Options"

Font: Runs a standard "font chooser" dialog for selecting the font used in the Lyrics Editor.

Auto fill: Copies lyrics from page to page. When on the Unsynchronized Lyrics page, copies lyrics line by line into the Synchronized Lyrics grid ready for editing. When on the Synchronized Lyrics page, copies synchronized lyrics into the Unsynchronized Lyrics editor.

Download: Do an online search for lyrics and install in the Editor if found. Search requires a valid artist and title in the tag.

Synchronized Lyrics

Synchronized lyrics contain a series of lyrics text pieces (lines, words, syllables) intermixed with timestamps that indicate at what specific time in the audio each piece begins. While UNsynchronized lyrics are stored in a tag as plain text, synchronized lyrics are stored as a single, contiguous binary object composed of text pieces interleaved with their associated timestamps.

A brief example will illustrate the use of the Synchronized Lyrics Editor, here using the following two lines of lyrics:

Strangers in the night

Exchanging glances

The simplest synchronization scheme would be a single line of lyrics per each grid line, with a corresponding timestamp indicating when each line begins in the audio:

Each line in the grid does not have to represent a whole line of lyrics, however. A more typical synchronization scheme would be based upon whole words or syllables. Below are the same two lines of lyrics timestamped by syllable this time:

Some basic formatting rules are visible above:

  • New line indicators ("^") always go at the beginning of a grid line (but none should go on the first line).

  • If a space character falls at the end of a piece of text, it should be placed at the beginning of the next grid line.

  • All entries should be listed in ascending order of time.

Controls:

Insert a new row above the current row.

Delete the current row.

Add a new row to the end.

Move the current row up or down. As in the Main Editor, any row can be swapped with any other row by dragging its row number button to another location while holding the control key depressed

Copy unsynchronized lyrics into the grid, one line of lyrics per grid line.

Clear the grid of all data.


Saving and Restoring Archives

Access: Menu > iTunes > Save or Restore iTunes archive, <Shift+F8>

Use the Save and Restore tool to create an archived copy of an existing iTunes library, or to restore one already created, to have iTunes reload it the next time it runs. This feature is primarily intended to be used with library sets (a set being comprised of both an iTunes XML file and an ITL file), but it will also archive or restore individual files. Note that library "archives" are library copies that you make yourself, as opposed to library "backups," which are made automatically by the program when it replaces iTunes library files with edited versions.

Create archive from iTunes library:

Saves the current iTunes XML library file ("iTunes Music Library.xml") in the current folder and with the name specified in the Library Name box.

Saves the current iTunes ITL library file ("iTunes Library.itl") in the current folder with the name specified in the Library Name box.

Saves both iTunes library files ("iTunes Music Library.xml" and "iTunes Library.itl") in the current folder with the name specified in the Library Name box.

  • Buttons in this section are enabled in accordance with whether the iTunes XML file, the ITL file, or both files are present in the iTunes folder. For example, if an ITL file is present but there is no corresponding XML file, then only the ITL button is enabled. If both are found, then all buttons are enabled.

Install as iTunes library:

Copies an archived XML library file from the current folder into the iTunes library folder with file name "iTunes Music Library.xml." If there is a corresponding ITL file ("iTunes Library.itl") already in place in the iTunes folder, it will be overwritten with a zero-length version (with an opportunity given to back it up first). This will coerce iTunes to load from the new XML file the next time it runs (otherwise, iTunes would load from the existing ITL file and overwrite the new XML file in the process). By program default, if a pre-existing XML file is present in the iTunes library before the copy, it is automatically backed up. To get a quick overview of the contents of any listed XML archive, select a file with the mouse, right-click it, and choose "Peak" from the context menu.

Copies an archived ITL library file from the current folder into the iTunes library folder with the name "iTunes Library.itl." By program default, if a pre-existing ITL file is present in the iTunes library folder, it will be automatically backed up. If an existing XML file is present in the iTunes library before the copy, the user is offered the option to back it up.

Copies both XML and ITL library files archived from the current folder into the iTunes library folder, with files being given corresponding names "iTunes Music Library.xml" and "iTunes Library.itl," respectively. By default, pre-existing copies of these files in the iTunes folder are automatically backed up before replacement.

  • Buttons are enabled in accordance with whether identically-named XML and ITL files are present in the Archives Folder. For example, if an XML file is selected and there is no identically-named ITL file, then only the XML button is enabled. If there is a like-named ITL, then all buttons are enabled.

  • To suppress the creation of backups when executing one of the above processes, hold the Control Key depressed while executing. You can disable backup creation entirely for these processes on the Install Options menu (below), if desired.

Several Install Options are available via the form's Main Menu, applicable when installing archived files into the iTunes library folder:

Confirm file replacements: Get confirmation before iTunes files are replaced during an archive install.

Backup replaced iTunes files: Create backups of iTunes files that are replaced when an archived file or file set is installed. By default, backups are saved in folder "Backups" in the program's install folder, but can be set to a different folder in Preferences. When enabled, this setting can be overridden to have the backup creation steps skipped, by holding the Control Key depressed while initiating an archive install.

Confirm backup creations: Get confirmation before creating backups of replaced iTunes files.

Issue backup affirmations: Affirm to the user that backups of replaced iTunes files have been made.

Other controls:

Reload the current folder view

Create a new subfolder beneath the current folder (also available via popup menu in the folder window)

Go to Archives folder*

Go to the Backups folder*

Go to the iTunes folder

Go to the previous folder loaded

* set in Preferences, located in the program's install folder by default


Main Editor

The Editor page is a two-view, 90-plus column table which loads with tag and file data from either 1) an iTunes XML library file, or 2) files at a particular location on your hard drive. When viewing an iTunes library file (iTunes Mode), the table can be linked to respective files on your hard drive, where present, so that the library and corresponding file tags keep in synch (see button [image]). Likewise, when viewing file tags (Tags Mode), the table can be linked to the iTunes library for the same purpose. Although not a requirement enforced by the editor, linking ensures that changes made to the iTunes library stay matched to physical file tags, and vice versa.

Most columns can be made visible or hidden from view, and the order in which they appear is adjustable via the Column Order & Visibility Panel. Access this panel with the Column button [image] on Top Toolbar B or use shortcut sequence <Ctrl+M>. You can drag-and-drop columns by dragging their column headers while holding the Control Key depressed. Up to three column configurations can be saved and recalled on the Columns Panel, or column properties can be reset to default values. The panel can be used to remove or restore a column from view, or to swap one column with a neighboring column. You can choose to reset a single column to its default width by right-clicking on its header cell and selecting the applicable function from a popup menu.

iTunes Mode - Editor is being used as XML library file editor.

Itunes Button Bar

Function buttons are shown in "compact" form and may be expanded onto a separate tool bar directly beneath, with captions added (MainMenu > View > Top Buttons > Expanded, or <Alt+J>).

Link-to-tags: When enabled, changes made to tag data in the iTunes library file are automatically propagated into corresponding file tags. When disabled, only the library file itself is updated*. Library Clinic supports many tag fields that are not supported in iTunes itself. Columns for these fields can only be made visible (and thus editable) when this option is enabled.

When not linking to tags, a choice can be made in Preferences' Behavior page whether columns that require tag access in order to populate them will be filled or not (choosing not to do this will increase the library load speed). If Preference setting "Do fast library loads when not linking to tags" is enabled, the following columns are not populated via file or tag access (but may still acquire data from the library, if present): File Size, Bit Rate, Sample Rate, Stereo/Mono Mode, Has Video, Playtime, Picture, Show, Season Number, Episode ID, and Episode Number. The Picture column can be set to load under all circumstances, however, by enabling option "Always get picture count."

*Exceptions: Changes made to tag fields Sort Name, Sort Artist, Sort Album, Sort Album Artist, and Sort Composer in MP3s, as well as changes made to fields Show, Season Number, Episode ID, and Episode Number in video files, are always propagated into a file's tag, since iTunes will always seek to acquire this information from physical file tags rather than from the library. Note also that iTunes will not pick up the Sort Show field from a backup file, and that it does not exist in file tags.

Catch up library file with tag changes: Compares tag and library data and replaces library data with tag data where they differ (Ctrl+Alt+5). The function will not remove library data, and will only change or add data where it differs.

Save or Restore iTunes archive: Executes the archive editor. Saves a copy of an iTunes library into the Archives Folder specified in Preferences, or retrieves one from this folder and installs it as the active iTunes library (Shif+F8). Note that this Archives Folder is used to store library backups that you specifically request copies of yourself. There is a separate Backups Folder (also specified in Preferences) that the program itself maintains, however, and which it uses to store copies of the iTunes libraries it replaces. A program-created backup can be restored using the Main Menu selection "iTunes > Restore iTunes backup," or Shift+F9.

Edit iTunes playlists: Executes the iTunes Playlist Editor (Ctrl+Alt+7).

Create new library: Creates a new, empty iTunes library file and executes the Add Files browse dialog for the addition of files (Shift+F1). New libraries created by this function can either include or exclude a standard, empty set of iTunes playlists (movies, TV shows, podcasts, etc.). See "Add standard playlist categories to new library files" in Preferences' on the Behavior page.

Add files to library: Opens a browse dialog for finding one or more files to add to the current library file. To remove files, highlight rows for removal (click or drag the mouse on the row number column), then left-click the mouse on the Editor and choose "Remove > Selected files" from the popup menu (or use Shift+F4).

Open XML file: Executes a browse dialog for finding and opening an iTunes XML library file. In iTunes Mode, the Browse button [image] also performs this function (Shift+F3).

Save XML file: Saves changes made to the current file (Shift+F5).

Save XML file as: Saves the current library file as another XML file with a different name (Shift+F6).

Open iTunes library file: Opens the iTunes XML libary file, "iTunes Music Library.xml" (Shift+F2).

Save and Install file as iTunes library (Shift+F7): Installs the current file as the active iTunes XML libary file ("iTunes Music Library.xml"). If a compressed library file exists ("iTunes Library.itl") and it is not already zero-length, backup copies of both existing files are made first and then stored in the "Backups Folder" specified in Preferences (by default, the subfolder "Backups" in the install folder). A zero-length ITL file is installed in place of the original ITL file. This induces iTunes to load from the replacement XML file when it next runs. You can suppress the creation of backups during this process, if desired, by holding the Control Key depressed while executing. A backup can be selected for restoration, if needed, by using the function at "Main Menu > iTunes > Restore iTunes backup." Visit "Backup file maintenance" on this menu to perform maintenance activities related to accumulated backup files.

File Presence Indicators: Indicator "ITL" is dark in color when an iTunes ITL library file ("iTunes Library.itl") is found to be present in the iTunes folder (and file length is greater than 0). Indicator "XML" is dark in color when an iTunes XML library file ("iTunes Music Library.xml") is found present. These Indicators appear faint when their respective files are not found.

File-changed indicator: Visible whenever one or more changes have been logged for the current XML file.

Tags Mode - Editor is being used as tag editor.

Tags Button Bar

Link to iTunes: When enabled, changes made to tag data are automatically propagated into corresponding fields in the iTunes XML library, if the file is listed there. When linking is enabled, files listed in the Editor that are also listed in the iTunes library (and thus subject to the link) are shown with light blue-colored row number cells (note rows 2 through 5 above).

Catch up tags with library changes: Compares library and tag data and replaces tag data with library data where they differ (Ctrl+Alt+6). This function does not remove data, and will only change or add data where they differ.

Save or Restore iTunes archive: Executes the archive editor. Saves a copy of an iTunes library, or installs one back again into iTunes (Shif+F8).

Update iTunes library (Shift+F7): Saves changes made to the iTunes XML libary file, "iTunes Music Library.xml," if linked to iTunes. If the iTune's compressed library file exists ("iTunes Library.itl"), and it is not zero-length, backup copies of both these files are made first, then stored in the "Backups Folder" specified in Preferences (by default, the subfolder "Backups" in the install folder). A zero-length ITL file is installed in place of the original ITL file. This induces iTunes to load from the replacement XML file when next it runs. You can suppress the creation of backups during this process, if desired, by holding the Control Key depressed while executing.

File Presence Indicators: Indicator "ITL" is dark in color when an iTunes ITL library file ("iTunes Library.itl") is found to be present in the iTunes folder (and file length is greater than 0). Indicator "XML" is dark in color when an iTunes XML library file ("iTunes Music Library.xml") is found present. These Indicators appear faint when their respective files are not found.

File-changed indicator: Visible whenever one or more changes have been logged for the iTunes XML library file.

Use the Browse button [image] to select a folder path to view. Only data fields that physically exist in tags are editable in this mode, even when linking to iTunes. Columns that represent iTunes-only data fields (thus do not have a corresponding tag field) cannot be made visible in this mode.

Single-Cell Popup Menu

Accessed by selecting and right-clicking the mouse on editable cell text anywhere in the Editor, functions on this menu operate on one tag field at a time. The lower, or "Tool," section shown below can be made to reside on the main level as shown, or on a submenu (see option "Place Single-Cell Popup tools on ..." in Preferences).

Library Clinic uses Windows' clipboard for all single-field Cut, Copy, and Paste operations. When performing these functions on tag fields that contain multiple data fields, like Comments, User Text, MusicMatch Bio, Lyrics, URL, Picture, and Object columns, an internal clipboard is used that can include data from supporting subfields, such as "description," "language," etc. When a Cut or Copy is performed on one of these columns, the program defaults to using its own internal clipboard. Subsequent Paste operations will use this data when pasting into the same or similar column from which the data came originally. If the internal clipboard's data came from an unlike column, or it is empty, Windows clipboard text is used instead. Although there is rarely a need, Library Clinic's internal clipboard can be manually cleared by executing a <Ctrl+C> (a "copy" shortcut sequence) while inside most single-field data cells, including empty cells. You can clear Windows' clipboard by executing a <Ctrl+K>, or clear both by executing <Ctrl+D>. You must be inside a data cell for these commands to be recognized.

Cut <Ctrl + X>: Moves selected text or tag field contents into the Clipboard. Besides operating on ordinary text, a cut can also be performed on Pictures or Encapsulated Objects. Even though there is no selectable text in these types of data cells, it works the same way. To cut Pictures or Objects, right-click the mouse on a column cell containing a number (which indicates their presence in the tag), then choose "Cut" from the popup menu to move the images or objects from the tag into the internal Clipboard.

Copy <Ctrl + C>: Copies selected text or tag field contents into the Clipboard. As with the "Cut" command, in addition to copying ordinary text a copy can be made of Pictures or Encapsulated Objects, even though there is no selectable text in these types of data cells. To copy a Picture or Object, right-click the mouse on a cell containing a number (which indicates their presence in a tag), then choose "Copy" from the popup menu to copy all images or objects in the tag to the internal Clipboard.

Paste <Ctrl + V>: Paste text, multi-field tag frames, pictures, or objects from the Clipboard into a tag. If all text in a cell is selected at the time of the paste, data may be pasted from either the internal clipboard or from Window's clipboard, depending upon the cell type and the current contents of the internal clipboard (see above).

Delete (Del): Remove contents of tag field from tag. When operating on fields in which multiple instances of a single tag field type can exist, like Comments, UserText, Pictures, etc., "Delete" removes only the first instance found in the tag. If a second instance of the same type is present, it takes the place of the first in the Editor's data view. In the Lyrics column, the first delete will remove only Unsynchronized Lyrics, while a second will remove the Synchronized Lyrics, if present. To remove ALL instances of multi-instance tag frames at one time, select the desired rows (highlight them) and use the "Delete" function on the Multi-Tag Popup Menu (see below).

Capitalize: Capitalize all words in selected text. The capitalization of contractions is handled in accordance with settings on the Options Panel. Capitalization of letters following specific symbols is performed in accordance with the Default Capitalization Options settings in the Capitalization Editor.

Capitalize±: Capitalize as above, then un-capitalize all active words listed in the Anti-Capitalization Editor (if enabled), and capitalize exactly all active words listed in the Exact-Capitalization Editor (if enabled).

All Upper: Convert all text to upper case in selected text.

All Lower: Convert all text to lower case in selected text.

Replace Illegals: Replace or remove illegal filename characters in selected text, as specified on the Illegal Character Replacement Editor.

Space to '_': Replace each space character with an underbar ("_") in selected text.

'_' to Space: Replace each underbar character ("_") with a space character in selected text.

'and' to '&': Replace each word "and" with an ampersand character ("&") in selected text.

'&' to 'and': Replace each ampersand character ("&") with the word "and" in selected text.

'&' to 'and the': Replace each ampersand character ("&") with the words "and the" in selected text.

'X to 'x: Convert each letter after a single quote to a lower case character, in selected text.

aB to a B: Add a space between capitalized words that have no space between them. Also adds a space before left parenthesis and left brackets where none are present.

" to ': Convert double quotes to a single quotes in selected text.

'/' to ?: Convert all backslash characters to another character, or characters, as specified by the Backslash Replacement setting on the "General 2" page in Preferences

'-' to Separator: Replace hyphens with the active Separator. Hyphens with a leading space or trailing space or both are treated as a single character by this function.

2 to 1 Space: Replace multiple, consecutive space characters with a single space character.

1 to 0 Space: Remove all space characters.

Add 'The ': Add the word "The" (followed by a space), at the beginning of text in a selected cell.

Auto Edit: The Editor has several built-in auto-editing functions that, when enabled, are automatically applied whenever text in a tag field is manually edited. See topic Options Panel for a full description of the following auto-edit options :

Auto-Capitalize

Anti-Capitalize

Exact-Capitalize

'X -> 'x

'Xx -> 'xx

'Mcx' -> 'McX'

'& xxx' -> 'and xxx'

Trim leading space

Trim trailing space

Trim overlength

Multi-Tag Popup Menu

When one or more rows are selected in the Main Editor (see Selecting Rows / Files below), a multi-tag popup menu is produced when the mouse is right-clicked on any column. The header of the selected column becomes highlighted, signaling that the clicked column is to be acted upon by the functions shown below:

The functions on this popup operate on all selected/highlighted rows. The top two sections operate on a specific column of data (one tag field), while the bottom section performs operations against whole tags. The top section is used for extracting file or path name text into tag fields. Refer to topic Auto-Extracting Text from Name-to-Tag for instruction on using these features. Use of the bottom two sections is described here, with the exception of selection "Rename." Refer to the end of topic Auto-Renaming Files for an explanation of how to use "Rename" for renaming files.

Column Operations

Paste: Pastes text or field data from the Clipboard into the column that has been right-clicked with the mouse, in each selected row. Pre-existing data in each cell is overwritten by the pasted data.

Paste Extra: Adds text from the Clipboard to either the front or the end of pre-existing text. Also may be used to paste manually entered text instead of Clipboard text.

User Text: Similar to the Paste option above, but allows manual entry of paste text, thus bypassing use of the Clipboard as the source for paste text.

Append: Add Clipboard text to the end of existing cell text. When used on file names, text is inserted between the end of the filename and the file extension.

Append with space: Prepend a space character to text in the Clipboard and append this text to the end of existing cell text. When used on filenames, text is inserted between the end of the file name and the file extension.

Prepend: Add Clipboard text to the front of existing cell text.

Prepend with space: Add Clipboard text plus one space character to the front of existing cell text.

Delete: Remove all tag field data from a selected column, in each selected file. Unlike the Delete command on the Single-Cell Popup Menu (see above), this command removes ALL instances of a tag field type found in a tag, rather than just the first one found.

Swap Right: Tag data in selected rows in the column right-clicked is exchanged with tag data in the column to its immediate right (if the column accepts the type of data being exchanged).

Swap Left: All tag data in selected rows in the column right-clicked is exchanged with tag data in the column to its immediate left (if the column accepts the type of data being exchanged).

'ID3v1 --> ID3v2 Col': Choose this feature to copy ID3v1 column data in selected files to the corresponding field in the ID3v2 tag. If a selected file does not contain an ID3v2 tag but supports one, a new tag is created. Note that ID3v1 tags are shown on Page 1 for MP3s only. Other types of files that support ID3v1s (AAC, APE, FLAC, MUSEPACK) can show these or another supported tag type on Page 2. The tag type being viewed at any given time for these files is selectable by popup menu on the File Type Toolbar, or on the Main Menu.

'ID3v2 --> ID3v1 Col': Choose this feature to copy ID3v2 column data for selected files into the same tag field of the corresponding ID3v1 tag. If a selected file does not contain an ID3v1 tag, it is created if supported.

Tools: Displays a submenu containing special-purpose editing tools identical to those found on the Single-Cell Popup Menu described above. Refer to this section for a description of function.

Row Operations

'Rename': Please refer to the end of topic Auto-Renaming Files for an explanation of how to use "Rename" for renaming files.

'ID3v1 * ID3v2 Row': Copy all ID3v1 tag data from selected rows into corresponding ID3v2 tag fields (MP3s only). If an selected file does not contain an ID3v2 tag, one is created. Note that the Editor optionally shows either ID3v1 tags or ID3v2. The tag type being viewed at any given time is selectable via popup menu on the File Type Toolbar button for MP3s.

'ID3v2 * ID3v1 Row': Copy all ID3v2 tag data from selected rows into corresponding ID3v1 tag fields (MP3s only). If a selected file does not contain an ID3v1 tag, a new tag is created.

'File Ops': Copy, move, or delete selected Editor files.

Copy Files...: From the mini-browser presented, choose another folder into which to place a copy of selected Editor files. Unlike the file-copy function in the File Window, this function will not create duplicate copies of selected files in the same folder in which they reside. Any selected files with the same source and destination paths are skipped.

Move Files...: From the mini-browser presented, choose another folder into which to move selected Editor files. Any selected files with the same source and destination paths are skipped.

Delete Files: Moves all selected Editor files into the Recycle Bin.

'Remove tags': In Tags Mode removes tags from files in selected rows. In iTunes Mode the option reads "Remove...," and produces a submenu:

Library tags: Removes all editable data fields from the listing in the iTunes library, and the text from respective columns in the Editor. Leaves the file listing in the library.

File tags: Removes physical tags from selected files while leaving the library listing untouched.

Library listings: Removes the file listing from the iTunes library file, and the file row from the Editor.

In most editing situations, tag data are not actually written into the Editor's table unless and until confirmation is received from the tag "update engine" that it has been successfully written. User-notification for most non-critical types of update errors is not normally given, unless option "Tag Errors" is enabled in Confirmations/Warnings in Preferences. Unless enabled, the only indication that an error has occurred may be that a tag change does not appear to "take" in the Editor, as the text in one or more cells appears to revert back to previous content when a change is attempted.

Selecting Rows / Files

Selecting files in the Editor is much like selecting files in a file browser. Here, however, the mouse is used on row numbers rather than on filenames. A single file is selected (highlighted) by clicking the mouse on the file's row number (first column). Click it again and it becomes deselected. Multiple files can be selected in several ways:

1) To select files one at a time, in any order, select the first one as above, then continue clicking additional row numbers to either add or remove rows from the selection.

2) To select consecutive files, position the mouse pointer over the first row number to be selected, then depress and hold down the left mouse button while dragging the mouse down or up the first column and across row numbers of the block of files you want to select. Repeat this process as needed to add additional files.

3) An alternate way to select consecutive files is to select the first file as described in 1) above, then hold the shift-key down while selecting the last. All files from the first to the last are selected. Repeat this process as needed to add additional files.

4) Select all rows at once by clicking the "Select All" button [image] on the Toolbar 2.

Cancel row selections at any time by clicking anywhere on the main Editor, navigating to another page or window, or clicking the "Select All" button.

Row and Column Rearrangement via Drag-and-Drop

Exchange one row in the Editor with another row by moving its row number button to another location: while holding the Control Key depressed, drag a number button onto another button to have the dragged row inserted there. Especially useful for fine-tuning a playlist order when creating playlists. Most columns can be moved in a similar manner.

Moving row 1 to row 2 | Moving the Artist column

In the image on the left above, row 1 is being swapped with row 2. In the image on the right, the Artist column is being dragged to the Title column position. If released there, the Title column will move to the right and the Artist column will take its place. This same column-swap between two neighboring columns could also be performed by right-clicking on the Artist column's header cell and choosing "Swap left" from the context menu. For more options and details about column arrangements and configurations see topic Column Order and Visibility.

Editing via Drag-and-Drop

Library Clinic supports editing via cell-data drag and drop from other OLE-enabled applications, or via file drag-and-drop of MS Excel files (.xls), or character-delimited files (.csv). See section Drag-and-Drop Editing in Preferences for a detailed discussion of the drag-and-drop editing process, the options available, and the program's behavior when text or objects are dropped onto the Editor.

Mouse Wheel Support

If your mouse has a mouse wheel you can scroll rows incrementally up or down by rotating the wheel. Intellipan is also supported via mouse wheel: depress and release the wheel anywhere on a scrollable Editor page and a four-directional arrow [image] appears on the grid. The page will auto-pan in whichever direction the mouse pointer is moved in relation to this image. For example, place the mouse above the image and the page auto-scrolls vertically up the spreadsheet through lower and lower row numbers. Place it to the right and the page auto-scrolls horizontally towards the right-most column. To terminate Intellipan, click the mouse anywhere on the surface of the Editor. If your mouse wheel is programmable, the wheel must be programmed as a third button in order to use this feature. Intellipan scrolling speed is adjustable in Preferences on the "General 2" page.

Editing Dates and Times

Non-iTunes Editor columns that show a year or a date can be edited with a "date picker," if desired, if the tag being edited supports a full date in the field being edited. Typically this would be a date in the "Year" or the "Original Year" columns for ID3v2.4 tags, or a date in the "Commercial" column, if the Commercial Editor is set to display a date there. When applicable, the Date Picker can be executed by pressing the backslash key (" / ") while inside a year or a date cell:

The Picker starts with the date already present in the tag, if there is one there, or starts with the current date if the cell is empty. Use the Delete key to reset a picker cell date to a "null date" (9/09/9999), to have a date removed from a field.

Itunes date cells do not use the "date picker" as shown above, but instead implement "number spinners" inside each applicable cell to assist in selecting dates and times:


MusicBrainz

Access: Menu > Edit > MusicBrainz, <Alt+B>, [image] button on SpeedButton Toolbar, or double-click on Top Toolbar B edit-box elements

MusicBrainz is a pubic-access, online database service from which tag data can be retrieved for audio files. This feature operates by first generating an audio "fingerprint" for a file, then submitting it for identification in the database. Because a file's audio is the only thing required for identification, MusicBrainz can be used to identify files that have no tag data, or even files that have no meaningful filenames.

To begin, use one of the access methods listed above to expose the MusicBrainz Lookup Panel:

Highlight one or more rows in the Editor, then click the Lookup button [image]. Lookups are performed on each file in two phases:

Phase One: This is the most time consuming phase. Decodes a file into raw wave data and submits a few seconds of audio to the MusicDNS server for determination of the file's acoustic fingerprint (the PUID, or Portable Unique Identifier). When this process is active, the logo for MusicIP (the parent organization of MusicDNS) appears on the Lookup Panel:

Phase Two: Once the PUID has been determined it is submitted to the MusicBrainz server for retrieval of tag data from the MusicBrainz database. While this connection is active, the MusicBrainz logo appears on the Lookup Panel:

When a query returns one or more results, new lines are inserted into the Editor beneath the filename being queried. Each new line contains the tag data returned along with a checkbox for enabling or disabling writing of the data into corresponding tags. The limit for the number of results returned for a single file is set in Preferences on the MusicBrainz tab.

Both MusicIP (Phase One) and MusicBrainz (Phase Two) are capable of returning tag data, but the data received from MusicBrainz are typically more complete. Results returned from MusicBrainz are always shown, if received, but if no results are returned then data from MusicIP is shown instead, where applicable. For each result returned, a "source marker" is placed in the inserted row's filename cell to indicate where the tag data came from:

>MIP - Tag data was received from MusicIP (Phase One).

>MB - Tag data was received from MusicBrainz (Phase Two). Exceptions: any genre's shown will have come from MusicIP, while any song lyrics returned result from a separate search elsewhere online.

Only check-marked rows are written to tags when the Write Tags button [image] is pressed, and only one inserted row per file can be check-marked for writing. Checked rows display text in bold font. A context menu is available via right-click on the Editor to assist in checking and unchecking selected rows. You can control which tag fields are written, if desired, by hiding or exposing specific columns (see Column Order & Visibility Panel) before writing the data. Only visible columns have data written to tags (exception: the PUID returned in Phase 1 is always written to a User Text frame, if this option is enabled in Preferences). Note that the Editor is placed in read-only mode while MusicBrainz data is present in the Editor. Click the Clear button [image] to remove the data and return the Editor to edit-mode.

Possible tag and other data returned by queries are: Title, Artist, Album, Year, Genre, Track, Tracks, Set, Sets, Artist ID, Title ID, Album ID, Album Type, Lyrics, and Amazon ASINs (ASINs and various MusicBrainz IDs may be optionally written into tags for use later - see the MusicBrainz section in Preferences). When an ASIN is returned, an attempt will be made to find, download and install an associated album cover, if this option is enabled in Preferences. Although the genre field is not supported by MusicBrainz, a genre will occasionally be returned with the MusicDNS query, and is shown when found. As with the genre, song lyrics are not archived on the MusicBrainz database, but the lookup process will check elsewhere online to find them, if enabled in Preferences.

To pause or cancel a multi-file lookup in progress, click anywhere on the surface of the editor, or click the Cancel button [image] on the MusicBrainz Panel (mouse clicks are buffered while online and can only be acted upon between file lookups, so some patience may be required).

The MusicBrainz service is a dynamic, ongoing community project that can always use interested participants. If you have one or more albums on CD that appear to be absent from the MusicBrainz database, please consider submitting them using their free Picard Tagger.

Please refer to the MusicBrainz page in Preferences for additional detail about the various options pertaining to the use of the MusicBrainz feature.

*WMAs that are DRM (Digital Rights Management) protected cannot be looked up using this feature. The PUID generation process requires that a portion of the audio be decoded into raw WAVE data for examination, and the DRM will not allow this.


People & Musician Credits Lists

Access: Click People/Musicians column cell button, or double-click the cell (depending upon Preferences setting)

The Involved People List and Musician Credits Lists store names of individuals involved in the creation or performance of audio content, and the functions or instruments of people during the process. These could be musicians, technicians, artists, photographers, or any other people involved.

Entries in the lists must always exist in Function-Name pairs (or Musician-Name pairs for the Musician Credits List), as shown in the Musician Credits Editor below:

To access either list, locate the "People" or "Musicians" column in the Editor then click on a cell in this column to expose the cell's "ellipse button" (or double-click in the cell if button-access is disabled - see "Sub-Editor Access Method" in Preferences):

Click the "Add Row" button to add a new Function-Name or Instrument-Name pair to the end of the list, or the "Delete Row" button to remove the row that currently has focus. Use the "Up/Down Arrow" buttons to move a focused row up or down in the list.

Each "Function" or "Instrument" listed must have a corresponding entry in the "Name" column, and vice versa. Any that do not, as well as empty rows, are automatically removed.

Function-Name and Instrument-Name pairs are shown in the Editor as a single line of text with a forward slash ("\") in between separating each entry. You can edit the list directly in the Main Editor's People or Musicians column; however, the Editor enforces the Function-Name/Musician-Name pair relationship that must exist there. Data in a People or Musicians column cell can be cut, copied, pasted, or deleted just as in other cells in the Editor but, again, the text is checked for validity before the operation is allowed to proceed.

The Musician Credits List field is only supported in ID3v2.4 tags in MP3s, and in M4A/MP4 tags. If you enter data into this column for a lower level ID3v2 tag than v2.4, and "Tag Conversion" is checked in the "Confirmations & Warnings" section in Preferences, you will be asked for permission to upgrade the tag to ID3v2.4 before the data are committed to the tag. If "Tag Conversion" is not checked, the tag must be manually converted before data can be entered.


Picture Viewers & Tools

Access: Left-click any cell in the Editor's Pic column, or right-click a Pic column cell and choose a tool from context menu. See below for additional access options.

Three image browsers are available for viewing images: a Main Viewer which shows tag images one-at-a-time at full-size, and two Thumbnail Viewers which display all images contained in a tag at once, in reduced size.

To determine if a tag contains a picture, examine the "Pic" column in the Editor. If one or more pictures have been detected within a tag, the column will contain a number representing the number of images found in the corresponding tag. To display the images or to perform other picture operations, simply click on a number to execute a Viewer. Which of two viewers is executed, either the Main Viewer or a stand-alone Thumbnail Viewer, is determined by setting "Clicking picture column runs..." on the first page of Preferences. Either may be executed at any time, however, by selecting it from a popup menu presented when a Pic column cell is right-clicked with the mouse.

Main Viewer

This main Picture Viewer provides options to:

Save a picture to a separate image file.

Execute the Picture Frame Editor (see detail below).

Execute the Thumbnail Viewer (see below).

Add, remove, or change a picture's caption or picture type.

Add an image to a tag.

Remove an image from a tag.

To move from one image to the next or previous tag image, use the left/right arrow buttons [image] [image], or use the Goto box [image] to jump to a specific image number (this box appears only when 3 or more images are present in a tag). To move to the next or previous file, use the up/down [image] arrow buttons. The keyboard's arrow keys can also be used in lieu of clicking the navigation buttons.

When checked, the Up/Down buttons advance the viewer to the next row/tag with an image to view. When unchecked, the viewer moves up or down one row per click. The checkbox is only visible when the "Goto" button (above) is not showing.

Thumbnail Image Panel

Toggle the Thumbnail Panel into view by clicking the button circled above on the Speedbutton Toolbar (click #3 on the Toolbar Toggle Pad [image] to expose this toolbar), or by selecting Main Menu > View > Thumbnail panel, or by executing shortcut sequence <Alt+L>. The panel dynamically creates thumbnails for images from whatever tag has current focus in the Editor, if the tag contains images, as you move from row to row. Or, you can use the navigation buttons below to change focus from file to file.

The Thumbnail Panel viewer offers options similar to those available on the Main Viewer for navigating and editing tags:

Save selected image to a file.

Add, delete, or change a picture's caption or image type.

Add image to tag.

Remove selected image from tag.

Move from one image to the next or previous tag.

View selected thumbnail full-size with an internal viewer (or double-click an image to view full-size).

When checked, the Up/Down buttons above advance the viewer to the next Editor row with an image to view. When unchecked, the viewer moves up or down one row (tag) per click.

Dismiss the Thumbnail panel and return to the File Window.

Thumbnail Viewer

To view a thumbnail image full-size, double-click its thumbnail, or select it with the mouse and click the View button [image]. As with the other viewers, the up/down arrow buttons navigate to other tags. As in the other viewers also, Auto-skip determines whether the the Up/Down buttons move one row at a time, or skips the viewer to the next row with an image to show. Button "Editor" executes the Picture Frame Editor (see below).

Picture Frame Editor

Click the "Editor" button on either the main Picture Viewer or the Thumbnail Browser to execute the Picture Frame Editor, or access it via popup menu by right-clicking any "Pic" column cell. With this editor you can get a detailed, editable overview of a tag's image content, add multiple images at one time, or rearrange images within a tag.

Restore Editor to its default proportions.

Clear the list of all pictures.

Remove a picture from a tag

Save a picture to an external file on your hard drive.

Open a picture with the program associated with its file type on your system.

Show selected image with the internal viewer.

Add one or more pictures selected in the Browser file window to the picture list/table.

Move image up or down in tag.

Clear the picture table and reload it from existing tag data.

Navigate Editor to previous file/tag.

Navigate Editor to next file/tag.

Accept changes made and close Editor.

Cancel changes made and close Editor.

Generate captions automatically from file names as files are added to the list.

Browse to files you want to add by using the file Browser in the upper section. To add a single picture, double-click its file name, or click the Add button after highlighting it. Add multiple files by highlighting multiple files, then click the Add button. Note that for ID3v2 tags, each picture should have a unique Caption, and each Caption should contain a maximum of only 64 characters. These restrictions do not apply to other tag types that support picture-in-tag, and they are not enforced in this editor even for ID3v2 tags unless image rearrangement is attempted.

The Location column in the picture list contains the word "tag" if a listed picture is already in the tag, while it contains the location of the image file on your hard drive if it has not yet been added. A tag is not actually updated with changes made in the editor until the OK, Up, or Down button is depressed.

To view a listed picture full-size with the program's internal viewer, double-click a row or cell in the Picture List (lower section), click the "Preview" button when a Picture List cell is selected. Double-clicking a thumbnail image, upper right, will load the full image for view. Images on the hard drive can be viewed by highlighting a supported picture file in the Browser's file window and clicking "Preview." To open a picture in your associated graphics program, select an editable Picture List cell, or a file in the Browser, and click the "Open" button.

Image Editing via Popup Menu

Some functions available on picture viewers are also available via a context popup menu produced when a "Pic" column cell is right-clicked with the mouse:

Use the popup menu to add, cut, copy, paste, or delete images in a manner similar to the way you would perform these functions with ordinary text. The cut, copy, and paste functions operate on ALL images within a tag, while the "Delete" function removes only the first one found in a tag. To remove all images at one time, first select the desired row or rows, then right-click on the "Pic" column and choose the "Delete" function from the Multi-tag Popup Menu (to select rows, click or drag the mouse on the row-number column - see topic Main Editor for more detail on selecting rows).

Supported Image formats are jpg, gif (including animated), jif, bmp, ico, wmf, emf, and pgn (this format is supported but cannot be displayed by the internal viewers). While picture-in-tag is supported in ID3v2, M4A, and MP4 tags.


Preferences

Access: Menu > File > Preferences, <Ctrl+P>

Note: Many preference changes are not retained between sessions in the unregistered program.

Use the Preferences section to inform the program of how you want it to behave in situations where options are available.

Archives Folder

Browse to a default path to use as the storage location for archived iTunes libraries. Archives can be saved and restored to and from iTunes using the Save and Restore iTunes Archive tool (<Shift+F8>).

Backups Folder

Browse to a default path to use as the storage location for backup copies of iTunes library files. Backup copies will be automatically created and sent here whenever a replacement library is installed in iTunes (automatic creation of backup copies can be suppressed, if desired, by holding the Control Key depressed while performing any save or update operation that would normally create them). To restore a backup, go to "Main Menu > iTunes > Restore iTunes backup" (<Shift+F9>). To browse, rename, or delete backups, go to "Main Menu > iTunes > Backup file maintenance" (<Shift+F10>).

Rename Root Folder

Enter or browse to a fully-qualified default path to use as the root folder for saving files renamed from a template, when renaming results in one or more files being moved to another location (a "Directory Restructuring" rename - see section "Add Backslash" in topic Auto-Renaming Files). All subfolders that are either used or created for rerouting renamed files are made to fall directly beneath the root folder specified here. Alternatively, check option "Rename path follows file path" to use each file's original path as the root folder below which subfolders are either created or used (note that in Tags Mode this will be a single path for all files, while in iTunes Mode this could mean a different path for each file). This option applies only to file renames that involve Directory Restructuring, and does not apply to files that undergo a simple rename-in-place, and thus remain in their original location.

Misc Output Folder

Enter or browse to a fully-qualified default path for saving playlists, images, tag lists, etc. created by the program. Or, click the Browse Button to select a path from a mini-browser. The path shown here is presented by each file "Save Dialog," whenever there is no previous file-save history for that particular dialog in the current session. Otherwise, each Dialog returns to the last folder it displayed. Alternatively, you can instruct Library Clinic to always use the current folder being viewed in Tags Mode for this purpose. Check the "Path follows active tags folder" checkbox to activate this option.

Clicking picture column executes ...

Choose the image browser you would like to run when the "Pic" column is clicked on Main Editor page 2: either the main Picture Viewer or the Thumbnail Browser (either can be selected at any time via context menu popup).

Put Single-Cell Popup tools on ...

Choose the location for the placement of auto-editing tools (e.g. Capitalize, All Upper, All Lower, Space to '_', etc.) on the Single-Cell Popup Menu.

Main level: Tools are always visible and available for use at the top level of the context popup menu as soon as it appears.

Submenu: Tools are placed on a separate submenu called "Tools." You must click the "Tools" menu selection on the main top level to be presented with the choice of tools to apply to cell text.

Sub-Editor Access Method

Button: Sub-editors, such as the Comment, Miscellaneous, User Text, Origins Detail, Commercial, URL, and Lyrics editors, are executed by clicking a small "ellipse" button [image] that appears on the right in respective cells when they are selected in the Main Editor.

Dbl-Click: Comment and other sub-editors are executed by double-clicking the mouse in respective cells in the Main Editor.

Either: Sub-editors can be executed by using either of the two methods above. In this mode, a single click is used to enter a cell, then either a double-click or a click on an ellipse button executes the editor.

Editor Auto-Advance

Down: Hitting the Enter key after a cell edit advances editing to the next cell field beneath the current one being edited in the Main Editor.

Right: Hitting the Enter key after a cell edit advances editing to the next cell to the right of the current one being edited in the Main Editor.

None: Hitting the Enter key after a cell edit does not advance editing to another cell in the Main Editor. The next cell for editing must be chosen by mouse click, Arrow Key advance, or Tab Key advance.

Sort Options

Default Sort Column

Choose which data column to sort on after loading tags and, optionally, after multi-file rename operations. Note that Library Clinic is able to perform most efficienty when the Editors are sorted by filename; a row-search algorithm is used that increases in efficiency as the Editors are more closely sorted by filename, either ascending or descending.

Sort empty cells last

Check to have empty Editor cells carry the least "sort weight," such that empty cells will fall at the end of a sorted group rather than at the beginning (this option can also be set with the "Sort empties" checkbox on the Sort Panel).

Sort after multi-file renames

Check to have the Editors re-sorted after multiple files have been renamed and the default sort column is the filename column.

Cell Drop-List Enables

Several data columns in Editor 2 can present drop-lists of suggested selections when cells are selected, allowing selection from a list if desired. Enable these drop-lists here. Each drop-list can be individually edited for content (see List Editors).

Orchestra/Band/Artist Album column ...

Tag field TPE2 in MP3's is referred to by different names by different applications. In the technical specs it is listed as the "orchestra/band/accompaniment" field, but it is often referred to and used as an "Album Artist" field. You can set a preference here.

Header: Choose the text to be used for the Editor's column header for this field, either "Orch/Band" or "Album Artist."

Show Artist if no Album Artist: Check to have the contents of the "Artist" field (TPE1) duplicated into the "Orch/Band"/"Album Artist" column (TPE2) when there is no data found for this field in the tag.

Subtitle/Description column ...

Tag field TIT3 in MP3's is referred to by different names by different applications. In the technical specs it is listed as the "Subtitle/Description Refinement" field, and may be referred to as either in different applications. You can set a preference here.

Header: Choose the text to be used for the Editor's column header for this field, either "Subtitle" or "Description."

For viewing lengthy text, a double-click on a cell in this column will load the text into a small viewer for easier viewing.

Drag-and-Drop Editing

These preferences apply to the drag-and-drop of Excel and CSV files, and the drop of Excel data, directly onto the Editor. They are used to manipulate the manner in which the program handles dropped files and data. The following discussion describes the actual tag update process; however, a preview of expected changes is always produced before any file name or tag data changes are actually initiated (please see topic Restoring Tags from a Backup for a description of the preview window and how it is used).

MODES: Data from a dropped file can be used to either Update" or Overwrite" existing data in the Main Editor:

Update (no file renaming is performed)

File Drop: In this mode, the first row in the dropped file is expected to contain the delimited-list of the column headers that were visible in the Editor at the time the file was created (this will always be true if the file was created by Library Clinic). The program searches the Editor for each file name referenced in each line in the dropped file. When a match is found, the column header for each subsequent data column in the dropped file is searched for in the Main Editor's column-header row (columns currently hidden in the Editor are excluded). If the column is visible, the data are deposited into that column at the intersection of the file name row in the Editor and the applicable column header. If the Editor is listing subfolders, file names in dropped files must contain fully-qualified names so that both file name and path can be matched.

Cell Data Drop: If data from an Excel spreadsheet is dropped into the first file name column, the data are handled as above (the first or second column of dropped data are then expected to be file names). Otherwise, data are applied row-by-row such that row 1 of the data are applied to the Editor row in which the data are first dropped (beginning with the column it's dropped in), row 2 of the data are applied to the following Editor row, and so on. Hidden columns do not receive cell data during cell data drops.

Overwrite (file renaming may be performed)

File Drop: Unlike Update Mode above, the program does not attempt to match file names in dropped Excel or CSV files with existing file names in the Main Editor. Instead, file names are applied row-by-row, such that the file name on row 1 in the Editor will receive the first file name in the dropped file, row 2 the second file name, and so on. Also unlike Update Mode, the dropped file is not required to have a first row composed of a delimited list of column headers. If a header row is present, data will be deposited into matching columns as is done in Update Mode. If a header line is not found, data are simply dropped into consecutive visible columns. When a file name specified for a row in a dropped file does not match the file name on the corresponding row in the Editor, a rename of the file to the name found in the dropped file is attempted. Confirmations from the user to allow each rename are requested beforehand, and renames can be reversed with the Undo button after operations complete. As in Update Mode, if the Editor is recursing folders then file names in the dropped file must be fully-qualified names.

Cell Data Drop: If dropped in the first file name column, data are handled in the same way as above; otherwise, data are handled as in Cell Data Drop in Update Mode.

Note that Library Clinic does not contain its own OLE server, which is required for some drag-and-drop operations. An OLE server is usually automatically available if, for example, any MS Office product has been installed.

CSV Delimiter: Choose one of nine possible delimiter characters to use as a data separator for CSR and CSV files created by the program: , ; # tab | @ * + &

When you load in or drag & drop a CSR or CSV file for restore of tag data, Library Clinic first attempts to parse the file using the delimiter specified here. If the parse fails, it attempts to determine the proper delimiter by examining the contents of the file itself. If the applicable delimiter still fails to resolve, an opportunity is given to specify a delimiter manually from the list above.

Enable: Check to allow the drop of CSV and XLS data onto a Main Editor page. When enabled, all unlisted CSV or XLS files in the current folder are added to the browser file list (regardless of current file mask setting). When disabled, all CSV and XLS files are removed from the browser file list, if the file mask is not set to show all file types.

Replace CSV double quotes: Normally when a standard CSV file is being created, if the character being used as a field delimiter (separator) is found to be embedded in the text being archived, the text is enclosed in double-quotes as a "flag" to a reading program that special handling is required to parse that particular block of text. The presence of the double-quote signals that text following it contains one or more delimiter characters that should not to be interpreted as delimiters. This standard CSV double-quote system works well most of the time, but fails when the text being stored happens to contain double-quotes within it. Data with embedded double-quotes can cause a standard CSV reader to quit reading a block of text prematurely so that, in the case of Library Clinic for example, subsequent text can be assigned to columns to which it does not belong when restoring. Enabling this option acts as a preventative for this type of problem by instructing Library Clinic to pre-process tag text so that it conforms to its own custom format (a modified CSV format). In this format, all instances of double-quotes in tag text are replaced with an unprintable character before being archived. Then when the file is read back again, instances of this character are converted back to double-quotes. Although Library Clinic will accept as backup files either standard CSVs or files formatted with this feature active, for greatest reliability it is recommended that only files made using this option be used for backing up and restoring tag text. Be aware, however, that CSV files created using this option will likely not conform to the standard CSV format and thus may cause problems for other programs if they are used or edited outside of Library Clinic.

Summarize Results: Check to have a summary of file-drop results produced after an update. Summaries typically report the number of tags in the dropped file, the number of files examined to see if file data should be installed there, and the number of tags actually updated.

Intellipan Scroll Speed

Sets intellipan scroll speed to one of five speeds, from very slow to very fast (see Mouse Wheel Support in topic Main Editor).

Play Options

Use internal player: Library Clinic contains an internal player supporting MP3 and WAVE files only. Check to use this player by default when playing these file types from within the program.

Volume: Master: Toggle button sets the internal player's volume slider to control either the Master Volume or the Wave Volume section of Window's mixer.

Default to WinAMP: When enabled, the program checks first for the presence of WinAMP on the system and, if found, sends files there to be played, rather than looking up an associated application to receive the file.

Double-clicking editor file name plays file: When checked, double-clicking a file name in an Editor file name column or in the File Window initiates a request to play it.

ID3v2 Options

Default Tag

From this drop-down list choose the default version of ID3v2 tag to be created when a new ID3v2 tag is formed.

Padding

Since most ID3v2 tags occur at the beginning of a file, extra tag space, or "padding," is usually added at the end of a tag's data section to allow for the addition of more data later without requiring the potentially time-consuming process of lengthening the file to make room for it. Padding can be set to 2 Kb, 4 Kb, or none. Library Clinic will not extend the length of a file unless a tag update requires more tag space than is currently available between the start of an existing tag and the end of any pre-existing padding. When a file must be lengthened, enough padding is added to round up file length to the nearest 2048 byte or 4096 byte file-length boundary, if padding is set to 2 Kb or 4 Kb, respectively. Note that FLAC tags also will use this setting to determine how much padding to include in a tag.

Compression

Enable: Check this box to enable the compression of ID3v2 tag data before it is written to a tag. Tag fields are examined on a field-by-field basis as tags are edited and updated. If compression will result in a space savings, the data are compressed before it is written to the tag. For the great majority of tags, enabling this feature will produce either no or only negligible savings in tag storage space. The data in most tag fields is quite small already, and tag sizes are usually padded-out to a multiple of 2 or 4 kb anyway. Notable exceptions can occur when, for example, a tag contains a non-compressed image type, such as a BMP, or contains a lengthy Comment, Lyrics, or other text field, or a large encapsulated object. Bear in mind that not all tag readers are capable of reading compressed tags, so enabling this feature could possibly render the compressed portions of your tags unreadable elsewhere.

You can have the tag data for only specific files compressed by selecting the desired files in the Main Editor, then choosing "Compress ID3v2 tags" in the "Edit" section of the Main Menu (or by choosing <Alt-F1>).

Preserve: Check this box to have Library Clinic keep the compressed data it finds in a tag in a compressed state when the tag is updated (even if the Enable option above is turned off). When disabled, compressed tag data are rewritten as uncompressed data when a tag is updated. This option is automatically turned on when Enable above is turned on, and cannot be turned off while that option is active.

Tag compression is only applicable to tag ID3v2 tags versions ID3v2.3 and above.

Unicode

Enable: When checked, new or updated tag text is stored in MP3s as Unicode UTF-16 encoded data rather than plain ASCII text. You can have tag data converted on demand between Unicode and ASCII by choosing "Convert ASCII tags to Unicode" or "Convert Unicode tags to ASCII" in the "Edit" section of the Main Menu. Only selected MP3s are converted if one or more Main Editor rows are highlighted, or all are converted if no rows are selected. Choice of text encoding is applicable only to MP3s; WMA tag text is always encoded in Unicode UTF-16BE, OGG and FLAC tag text is encoded in Unicode UTF-8, while VQF and MP4 is in plain ASCII.

Preserve: Check this box to have Library Clinic keep the Unicode MP3 tags it finds encoded in Unicode UTF-16, even if the Enable option above is turned off. This option is automatically turned on when Enable is turned on, and cannot be turned off while that option is active.

Default Language

Certain ID3v2 tag frames can have language descriptor codes associated with them in order for tag readers with a need for this information to determine which language a particular tag field is written in. Choosing a language from this drop-down list tells Library Clinic that this is the language you typically write in, and that you would like to have the program automatically assign the descriptor code for that language to all new Comment, Lyrics, or other fields as they are created. A drop-down list identical to that appearing here also appears in respective sub-editors for Comment, Lyrics, and Commercial frames License fields. Whenever one of these editors is executed, its own default language selection is automatically set to "mirror" the selection you make here. When a tag is loaded into an editor, and there has been no descriptor already assigned to its language field, the default language chosen here is automatically applied (see topic Comment Editor for a more detailed discussion of this behavior).

Default Currency

Ownership and Commercial Frames contain product price fields, and prices are always stored together with an international code identifying what type of currency the price is given in. When entering a price in the Commercial Frames Editor without having first selected a currency type for it on the editor itself, the currency specified here is automatically associated with the new price entered.

When a price field has been selected for display in the Commercial column of Editor 2 (the choice of which field to show is made on the Commercial Frames Editor itself), the price field becomes directly editable in the main Editor by selecting its cell contents and typing in a new value. Normally the new price keeps the old Currency type that was first assigned to this field. However, if an empty cell is given a new price, the new price automatically becomes associated with the Default Currency specified here. To change it, use the Commercial Frames Editor to select a different one.

Remove empty frames while loading

Some tag editors may leave empty ID3v2 tag frames inside a tag, even though the data they contained was removed. Such frames are wasteful of tag storage space and can impact tag reading speed to a small degree. Check this option to have empty frames automatically removed as tags are being read during a folder scan. This process may lengthen the tag-reading process slightly, so it is recommended that it not be left on indefinitely.

Remove private frames while loading

For Media Player users. Some tag reading programs are not able to process ID3v2 tags that contain Private Frames. Check this option to have Private Frames automatically removed as tags are being read during a folder scan. This process may lengthen the tag-reading process slightly, so it is recommended that it not be left on indefinitely.

Include v1 genre index in v2 genre

The technical specification for the ID3v2 genre field allows for the inclusion of a corresponding ID3v1 genre list index number, when one exists, in addition to and preceding the genre name itself. Some tag readers. however, are not able to parse genre names correctly when this type of format is used. Check this box to have ID3v1 genre index numbers included with ID3v2 genre names; uncheck it to have only genre names placed in ID3v2 genre fields.

Store Artist after Orch/Band

For iTunes users. Atypical of other tag readers, iTunes will pull data from the Album Artist field (sometimes referred to as the "Orchestra/Band" field) and display it in the Artist column, if there happens to be no Artist data present in the tag. Even if both the Artist and the Album Artist fields contain data, iTunes will still display Album Artist instead of Artist if the Album Artist frame is not physically located ahead of the Artist frame in the tag. Checking this option instructs Library Clinic to restructure a tag in two ways in order to coerce iTunes into keeping Artist and Album Artist data separate: 1) If there is no Artist data present in a tag, but there is Album Artist data, an empty Artist frame containing no actual text is added, and 2) tag frames are arranged in a tag such that the Album Artist frame is always located ahead of the Artist frame, if both frames are present in the tag. When this option is enabled, the setting "Remove empty frames while loading" above is overridden for the Artist field.

Force ASCII picture format

For iTunes and MusicMatch users. Some tag reading programs capable of displaying artwork or pictures in tags are not able to show pictures that are stored in Unicode-compliant form. By default, Library Clinic installs a picture using text encoding that is in keeping with that used in the rest of the tag itself; that is, an ASCII-formatted picture frame is installed in a tag that uses ASCII text encoding, while a Unicode-formatted frame is installed in a tag that is Unicode encoded. Check this option to have Library Clinic always install an ASCII-formatted picture frame, regardless of whether the tag itself is ASCII or Unicode.

Apply unsynchronization

Check this box to have "unsynchronization" applied to a tag's contents when it is saved or updated. The purpose of unsynchronization is to make ID3v2 tags compatible with older hardware and software that is not ID3v2 "tag-aware" (this feature should not be enabled for any other reason). Tag data can sometimes contain units of data that may appear as audio synchronization data to "unaware" software or hardware. This, in turn, can cause unpredictable behavior or noise when the file is edited or played. When "unsynchronization" is applied, these potentially problem-causing data units are converted to benign, non-conflicting units that cannot cause these types of problems. Tags which have had unsynchronization applied, however, should be edited only with tag editors (such as this one) that are capable of detecting unsynchronization and reversing it, as needed, as they are read and before they are altered again.

ID3v1 Default Tag

Choose the default version of ID3v1 tag (ID3v1.0 or ID3v1.1) that will be created when a new ID3v1 tag is created. Note that the "Track" field is not supported in ID3v1.0 tags, and if a tag is at version ID3v1.0 when a track is added it is automatically promoted to version ID3v1.1 to accommodate the addition, regardless of the selection made here. Technically, when an ID3v1 tag that contains no track number is updated, the space normally occupied by a track number is filled with zeros when the option is set to "ID3v1.1." When at "ID3v1.0," the track number area is filled with space characters.

MP3 Processing Options

By default, Library Clinic makes only a cursory examination of files for determining their audio characteristics when loading. While this maximizes the tag-loading speed, files that are defective in some way, or that do not conform to expected structural standards, can be misread to produce inaccurate file specs (bitrates, sample rates, playtimes, etc.). Each of the processing options below is designed to improve the reading accuracy of aberant files, but each will also add some additional overhead to the tag-reading process.

Process Xing-less VBRs: Check this option to enable additional processing of VBR (variable bitrate) MP3s that are found to have no Xing header. Typically a VBR file without an Xing header will have the correct encoder identified in the ID3v1 Encoder column but will show an incorrect Bitrate and Playtime, since the file will be perceived as a constant bitrate file. Most VBRs contain an Xing header in front of a VBR header, from which their VBR status, bitrate, and playtime can be easily acquired. Without this, specs must be obtained by "stepping though" a file frame-by-frame to compute them. The additional overhead for this option depends upon the mix of encoding types being loaded.

Search for headerless VBRs: Check this option to enable a search for VBR (variable bitrate) MP3s that contain neither an Xing header nor a VBR header. Typically a VBR file without either of these headers will be misidentified as a CBR (constant bitrate) file, usually of type FhG or Blade, and will show incorrect bitrate and playtimes. Searching for this type of defect involves partially stepping through many CBRs to verify audio frame-by-audio frame whether they are VBR or not. When found to be VBR, a file is stepped all the way through to compute the bitrate and playtime. A brief search is also performed at the bottom of a file for the appearance of an encoder ID. A VBR identified in this way and that has no encoder ID found will have the encoder listed as "Unknown" in the ID3v1 Encoder column. The file will show a correct bitrate and playtime, however. Enabling this option typically adds noticeably to the tag-reading time. Leaving it enabled indefinitely, therefore, is not recommended.

Validate CBR specs: Check this option to enable testing and validation of CBR (constant bitrate) audio specifications found initially for MP3s. By default, and to maintain the greatest tag-loading speed, Library Clinic examines only the very first audio frame in a CBR MP3 to determine its audio characteristics, and the results are not checked for accuracy. Usually this is sufficient, but occasionally a first audio frame will be defective or malformed in some way, often because the encoder that produced it got off to a shaky start. When this happens, inaccurate audio specs are reported (bitrates, sample rates, playtimes, etc.). Enabling this option brings to bear some "second look" processing to better ensure that a representative audio frame is used to compute audio specs. Also enabled with this option is an end-of-file search for a Lame CBR encoder ID, since files with no clear encoder markings at their beginning typically default to being identified as Fraunhafer encodes otherwise. The additional overhead added by this option is usually modest.

Tracks/Sets

Access

Tracks and sets on the Main Editor pages are always manually editable. However, when this option is set to "Spinner," a "number spinner" appears in each track and set cell when selected, allowing easy increment or decrement of numbers in these cells.

Allow Leading Zeros

Set this check box to enable leading zeros in track and set columns. When disabled, leading zeros are automatically removed from track and set numbers when entered or displayed. Leading zero support is not applicable to ID3v1 tags, nor is it available when the Access method above is set to "Spinner."

Allow track/set > tracks/sets

Set to allow "track" and "set" numbers entered to be larger than corresponding "tracks" or "sets" numbers, and to allow "tracks" and "sets" numbers entered to be smaller than corresponding "track" or "set" numbers, when they exist. When unchecked and manually entering an out-of-bounds track- or set- type number, a warning is issued and the update is refused. When unchecked and the number is entered via an automated edit function, the out-of-bounds number is removed.

"Tracks" string when no track

In most tags, track and total track numbers are stored together as a single, slash-separated string (e.g. track 4 of a total of 12 tracks is stored as text "4/12" in the tag itself). If there is no track number present when a track string is added or updated in a tag, the missing track number can be represented in one of two ways, either by including a leading zero in the string (e.g. "0/12"), or by excluding any number from in front of the slash (e.g. "/12").

Include total tracks/sets in tag: Uncheck to disallow the alteration of total tracks and total sets numbers in tags. When not checked, tracks and sets number can be deleted, cut, or copied, but they cannot be changed to a different number (other than zero).

See topic Tracks & Sets for more detail about Track and Set behavior.

Backslash Replacement

Chooses which character is used to replace a backslash (' / ') character when found in text while using the "slash" replacement tool on the Single-Tag Popup Menu.

Fonts

Use these tools to adjust the size and appearance of fonts used to display data in respective lists within the program. Change font sizes by clicking the up/down arrow keys to the right of the text box showing the current font size. Select Bold or Regular font by clicking the small button to the left of a font-size box. To edit other font styles, or to select a different font, click one of the font buttons beneath these tools to bring up a standard Windows font dialog box. Click the Apply Button on this dialog to both preview and apply your changes, then hit the OK Button to accept them.

Fixed Cells

Choose the appearance of row number and column header cells. Choosing Flat renders cells as plain, square, and gray with a dark outline. Choosing 3-D Plain produces cells with a gray, three-dimensional look. Choose 3-D Gradient for a three-dimensional look with color gradient added. The 3-D appearance may not be appropriate on some systems. On systems with slower video systems, excessive "flicker" may result when selecting cells when this attribute is active.

Grid Lines

Grid lines between Editor rows can be chosen as thick or thin or not present.

Colorization

Allows customization of font and other colors in the Editor:

Font

Filename Color: Choose font color for Filename column text.

Location Color: Choose font color for Location column text.

Year & Track Color: Choose font color for Year and Track column text.

Enable: Enable/disable font colorization.

Banding

Vertical: Enable vertical (column) color banding.

Horizontal: Enable horizontal (row) color banding.

Band 1 Color: Choose cell background color number 1. Applied to every-other column, if V Banding active, or every-other row, if H Banding active.

Band 2 Color: Choose cell background color number 2. Applied to columns not colored by Band 1, if V Banding active, or rows not colored by Band 1 colors, if H Banding active.

Enable: Enable/disable column/row color banding.

Row Selection Color: Choose color used to highlight selected rows.

Browser Background Color: Choose Browser background color.

Apply Windows' theme colors (Vista only): "Skins" the program, when checked, using current Windows' desktop theme colors. Primary skin color is taken from Inactive Caption color. Secondary, or gradient, color is generally white or cream. When unchecked, or the OS is not Windows Vista*, standard "button gray" is used as primary color, while white or cream is used as secondary.

Resets all colorization settings to default values.

Enable Editor folder nodes

When checked, files are grouped by location in the Editors, and a "folder node" column is added on the left on each editor page, with folder icons placed at the start of each group. Click a folder icon to collapse a file group down to a single line. Click it again to expand it. While folder nodes are active, files are maintained in groups by location while editing, sorting, renaming, etc. Tag synchronization is turned off whenever one or more folder nodes are collapsed, and the copying of tag data between ID3v1 and ID3v2 tags is not always allowed. Folder nodes are automatically expanded to accommodate some file operations, such as file renaming and file moving, and when the Rename Page or the Column Page is selected.

The folder node option can also be enabled or disabled just by double-clicking the top left-most cell on either Editor page. Node enable/disable, expand and collapse options are also available via popup menu by right-clicking the mouse anywhere on the first column.

Show Editor file icons

Check to prepend an identifying file-type icon to each file name in each file name column.

Confirmations / Warnings

Multi-file rename: Confirm a request to rename multiple files.

Multi-file rename undo: Confirm a request to reverse a previous multi-file rename.

Itunes library install*: Confirm before replacement of the iTunes library ITL and XML files [image].

Itunes library update*: Confirm before overwriting the iTunes library XML file [image], [image].

Itunes backup restore*: Confirm before replacing of the iTunes library ITL and/or XML files by a backup copy (<Shift+F9>).

Save/Update XML file*: Confirm before overwriting a non-iTunes XML library file [image], [image].

Catch Up operations: Confirm requests to catch up iTunes with tags [image] or tags with iTunes [image].

Other file saves: Confirm before overwriting file types that are not iTunes-related.

Other file operations: Confirm before file delete, file move, creation of tag data for one type of tag by using tag data from another.

Tag Compression: Confirm a request to compress ID3v2 tags in selected MP3s (MainMenu > MP3 > Compress ID3v2 tags, or <Alt+F1>).

Tag Conversion: Confirm requests to convert ID3v2.3 tags to ID3v2.4 tags in selected files, or vice versa ( (see MainMenu > MP3). Also controls confirmation requests for data swaps, and paste and edit events for the Musician Credit List column when editing ID3v2.3 tags. Since version 2.3 does not support the Musician Credits List, an ID3v2.3 tag must be upgraded to ID3v2.4 in order to enter data into this column. Confirmation is requested for this operation when this option is checked.

Tag Removal: When checked, the user is asked to confirm a request to remove tags from selected files.

Tag Errors: Most non-critical errors detected by the program while reading or writing tags are not reported by the program unless this option is checked. Errors detected by the operating system are not affected by this setting.

Whole-tag paste: Confirm requests to paste data from multiple tag fields in one tag into other files (see PasteDown Panel).

Warn if no change: When this option is enabled and there have been no changes resulting from a Preview, Rename, or Undo, the user is informed that no changes have resulted from these actions.

* not applicable to save/restore of iTunes archive files

Behavior

Keep file's original timestamp after tag update: A file's date and time is automatically updated by the OS to reflect the current date and time when it is altered or updated. Check this box to have Library Clinic keep a record of a file's original timestamp before a tag update is made, and have it restored afterwards.

Allow rename of read-only files: Check to enable the renaming of files marked as "read-only" on your file system. Uncheck to disallow the renaming of read-only files.

Selecting a second row unselects the first row: Ordinarily, clicking on the row number of any Editor row selects that row and automatically adds it to the collection of selected rows. When this option is checked, however, this behavior is reversed. Clicking on the row number of any second row automatically dismisses selection of the first row and selects the second. Enabling this option can be useful when filename formats vary widely from row to row, forcing extraction of text from filename-to-tag a row at a time. This option only effects behavior when one row is selected in the Editor. Note that you can momentarily reverse the default behavior selected here by holding the Control Key depressed while selecting the second row.

Show popup menu hints in statusbar: When enabled, popup menu hints describing the function of context menu selections are displayed in the Statusbar as the mouse is passed over them.

Enable separate Separators for each page: The Separator used for file name constructions and file name-to-tag extractions can be specified on the Main Menu, the Main Editor's multi-tag popup menu, or on the Rename Page. By default, when you change it in one location, the change is propagated everywhere it's used. Checking this options allows a different Separator to be specified for each of the three primary pages that use it: the two Main Editor pages and the Rename Page.

Hide program while using main picture viewer: Check to have the main program removed from view while viewing images with the main Picture Viewer.

Auto-refresh after folder scanning enabled/disabled: Check to have tags automatically re-read and edit lists refreshed whenever folder scanning is enabled or disabled with the Scanning Button [image] on the top panel.

Auto-show/hide location column: Automatically expose the Location column when folder scanning is enabled, and hide it when it's turned off.

Auto-position subeditors: Check this option to have the program automatically position subeditors (the Comment Editor, User Text Editor, URL Editor, etc.) to the right or left of the column being edited, whenever possible.

Return to start row after using subeditor or viewer: Subeditors and image viewers can browse from row-to-row, tag-to-tag while in use. Check this option to have the program return the Main Editor's focus to the row that had focus before the subeditor or viewer was executed, after the subeditor or viewer closes.

Enable previews when renaming via popup menu: By checking this option you can choose to preview proposed file name changes before files are actually renamed when using the "Rename " function on the Main Editor's context popup menu. When enabled, current and proposed file names are presented in a list for approval before renaming is performed. When unchecked, file renames via popup menu are performed immediately and without preview. Applies to renames via popup menu only; whole-folder renames performed on the Rename Page are always previewed.

Add 'Send To' link to system context menu: Add a link file "Library Clinic vX.X.lnk" (where "X.X" is a version number) to the "Send To" section of the system context menu. With this link installed, you can select a file or folder in a file Browser, right-click it with the mouse, then choose the link from the context menu's "Send To" section to have Library Clinic execute into a selected folder, or a selected file's location. This option is not enabled on 64-bit machines.

Do fast library loads when not linking to tags: Some columns available in iTunes Mode are populated with data obtained directly from files rather than from an iTunes library, since the information is not (or may not be) available there. These columns include the File Size, Bit Rate, Sample Rate, Stereo/Mono Mode, Has Video, Playtime, and Picture columns. The process of opening and examining files to retrieve information for these columns can significantly increase the processing time required to load libraries into the Editor. When this option is enabled, these columns will be populated only if it's available in the library itself, and will not be retrieved from files if not found. This can greatly increase the library load speed. Applicable to iTunes Mode, only when the library view is not automatically linking to physical files via the Link-to-Tags button [image].

Always get picture count: When fast library loads are performed, as described above, do a quick link to file tags just to retrieve a picture count for populating the Picture Column.

Update empty fields when catching up: When catching up iTunes with tags [image], empty tag fields are normally ignored to prevent corresponding library fields that are not empty from being unintentionally erased. Likewise, when catching up tags with iTunes [image], empty iTunes fields are ordinarily ignored for a similar reason. Checking this box will specify that you want blank fields to be considered valid data when performing these functions. This will, in effect, change the catch up behavior from an "update" to a "copy."

Update archives & backups with filename changes: If you change the name of a file that is listed in an archive or a backup file, the entry for that file normally becomes invalid because the file referenced is no longer found by the name listed. With this option enabled, file name changes made are automatically propagated into iTunes XML library files located in the Archives Folder and Backups Folder (specified on Preferences page "General 1," above). When an XML file is updated in this way, an underbar followed by an "N" ("_N") is appended to the original archive or backup file name, thus denoting that a file name change has occurred in the file.

Add standard playlist categories to new library files: When creating new libraries, iTunes normally adds several default categories of playlists, from "90's Music" through "Podcasts." Check this box to have these categories added to new libraries you make with iT Library Clinic.

Minimize after launching iTunes: Auto-minimize Library Clinic into the Windows' taskbar when launching iTunes via the launch button [image] (<Alt+8>).

MusicBrainz is a free online database service used by Library Clinic to look up tag data upon request (see Help section MusicBrainz).

MusicBrainz Server: Web address and port number to use for accessing the MusicBrainz server. Click the "Set to default" button to use the standard, default server address and port number.

Proxy Server: If you use a proxy server, enter the applicable name, port number, user name, and password here as needed for accessing the MusicBrainz server. Check the "Use proxy to connect" box to enable use of the proxy server.

Lookup Options

Max Results: Many songs are found in more than one album, and multiple results can be returned for a single song query. Set here the maximum number of results accepted for a single file. The MusicBrainz server currently imposes an access limit of one query per second on its server. When max results are set higher than 3 here, query speed is throttled back slightly to avoid offending the server.

Query Delay: At the time of this writing, MusicBrainz imposes a limit of one query per second when querying for tag data, to keep its server from being overly burdened. Each file may take multiple queries to process, depending upon the "Max Results" setting above. If "530 errors" are experienced (pictured below), try increasing the query delay.

The default delay is 450 milliseconds. On most systems, this delay plus normal processing and connection delays will combine to satisfy the 1-second delay requirement. Note that a 503 error is a generic error that can occur for many other reasons besides a low query delay.

Confirm before lookup: Quiz user for confirmation before connecting online and looking up tags.

Auto-checkbox results: Multiple query results may be returned for a single file being looked up, and each result is placed in a new line with its own checkbox directly beneath the file being queried in the Editor. Check this option to have the first result received automatically check-marked. Only check-marked rows have their data written to tags when the "Write Tags" button is pressed (see Help section MusicBrainz).

Store PUIDs in tags: When a PUID is returned from MusicDNS, install the PUID into a User Text tag frame in the file's tag. Not supported when querying on ID3v1 tags.

Use PUIDs in tags: Before executing a query, look through a file's User Text tag frames for the presence of a PUID already saved during a previous query. Use it, if found, in lieu of re-querying MusicDNS to calculate the same PUID again.

Write Options:

Confirm before writing tags: Quiz the user for confirmation before writing MusicBrainz data to tags.

Store MusicBrainz IDs in tags: When checked, the following pieces of information (if returned) are stored in separate User Text frames when tags are written after the query: Artist ID, Album ID, Track ID, and Album Type. Not supported when querying on ID3v1 tags.

Store Amazon ASIN in tags: Place the Amazon.com product URL for the file's album of origin in a Commercial Information URL frame, if this information is returned by a MusicBrainz query. If desired, the Editor can be configured to display these URLs in the Editor's URL column (see topic URL Editor), allowing one-click access to the location on Amazon where the file's album is sold, and where additional information and cover shots can often be obtained. Supported only in tags that support multiple Commercial URL frames. Not supported when querying on ID3v1 tags.

Download and install album art: When an Amazon ASIN is returned by a MusicBrainz query (see above), visit the URL and look for a link to an album cover shot. If found, download and install the image in the file's tag. Option is acted upon if the ASIN is already present in a Commercial URL frame in the file's tag, implying that the image has already been downloaded (to override, remove the ASIN).

Download and install lyrics: Search online for song lyrics, and download and install in tag when found.


Restoring Tags from a Backup

Access: Menu > File > Restore tags, <Ctrl+Alt+R>

If you have created a backup of your tags as a CSV or XLS file using function "Main Menu > Save Taglist as" (<Ctrl+1> or <Ctrl+5>), or if you have created a list of tags outside the program, you can use this feature to restore or import them. Initiate a restore operation by dragging and dropping a CSV or XLS file directly onto the Editor, or browse to a backup file on your system via MainMenu > File > Restore tags.

As a usage example, assume we have the list of tags shown below and would like to restore a few tags fields to the content they had at a previous backup:

Select "Restore Tags" from the Main Menu and browse to the appropriate backup file, then click the "OK" button to load the backup file and have a preview of anticipated results created (click the Cancel button on the surface of the Preview window at any time to pause or cancel a preview in progress):

Expected changes are shown in bold type in rows directly beneath rows containing existing tag data in regular type. Each file name has a check box to its left used to enable or disable changes for that particular file during a subsequent restore. Files with changes detected are automatically checked as a preview is produced. You can check or uncheck individual files by clicking anywhere on a file name line or on its change-preview line. Or select multiple rows as done in the Main Editor, then right-click on the Preview and choose "Check selected" or "Uncheck selected" from the context menu. Use the same context menu to select or unselect all rows, or use the button at the bottom of the Preview. Once satisfied with changes shown, click the "Commit Changes" button to write the changes to tags (clicking anywhere on the surface of the Main Editor will pause the operation once begun, and allow cancellation).

In the initial Preview, tag fields that contain data where the backup file does not are flagged with a "***REMOVE***" designation. These tag fields are cleared during a restore.

Comments, User Text, Lyrics, and MusicMatch Bio fields may contain long textual data, not all of which is shown in the Main Editor. CSV backups support the backup of lengthy text by retrieving the full text directly from the tag, rather than backing up just the visible portion shown in the Main Editor. For XLS backups, on the other hand, there is an Excel-imposed limit to the length of text that can be backed up per cell. So, to avoid overwriting lengthy text that may not have been completely backed up in the first place, if a Main Editor cell contains text in excess of 200 characters, a restore for that cell is disallowed. The Preview cell is flagged with a "***SKIP***" designation, and that cell is not be operated on during a restore.

Only columns visible and editable in the Main Editor are updated when a Preview or Restore is performed. Although a backup file may contain data for other columns, data belonging to hidden or non-editable columns are simply skipped. As with most multi-file functions in Library Clinic, the Restore function operates either on selected Editor rows, or on all rows if no rows are selected. By adjusting column visibility and selecting rows, it is possible to restore anywhere from just a single tag field to a complete library of tags.

There are inherent limitations to using CSV and XLS files for backing up and restoring tag data. Only the first instance of a multi-instance field can be accommodated - only the first Comment, for example, if a tag contains more than one. Many tag fields may also contain sub-field data that is not backed up. The Comment field, again, has Description and Language sub-fields that may also contain data in addition to the comment itself. This extra information is not included in a backup and cannot be restored using this restore feature. Also, some types of tag data, such as images and encapsulated objects, are not stored in a tag in a textual format and do not lend themselves to this type of backup and restore medium. If you need to get around these limitations, consider backing up to an MDB database file, an option available in Tag Backup & Restore.

Note that tag data entered via a Restore operation is processed exactly as if the data were entered by hand. Any auto-edit options in effect at the time of a restore are applied just as if the data were entered manually. Thus, for example, if auto-capitalize is in effect when restoring, a title such as "any song title" will restore as "Any Song Title." Similarly, if Preferences is set to disallow a Total Tracks number from being smaller than a Track number, and the backup file contains one of these situations, the Total Tracks number will not be restored.

Both CSV and XLS backup files can be edited (or even created) outside the program, if desired, and then imported later.

Two things are required in a backup file in order for Library Clinic to be able to use it for a Restore, or a Drag & Drop edit. First, the top line in the file must contain the list of column names in Library Clinic into which the data is to be restored (backup files produced by Library Clinic itself will automatically contain this line). Second, a "File Name" column must always be present. The file name column must be either the first or the second column listed (the first column may be a row number column, if desired, but this column is not used during a Restore). In addition, if the program is listing multiple folders at the time a Restore is initiated, filenames in the backup file will be required to contain fully-qualified names so that both a filename and a path name can be matched.

Auto-Renaming While Restoring

XLS backup files can be used to automatically rename files at the same time that tags are restored, if a column is added to the backup file with a header name "Rename To." During a restore preview, the Library Clinic looks for a column by this name and, if a potential new name is found in this column, displays it in the "File Name" column in the applicable preview row. The program will attempt to rename existing files to new names found in the backup file during a restore. File extensions are automatically added to text found in a "Rename To" column if not already present.

See Drag-and-Drop Editing in Preferences (page General 2) for additional details about restoring from CSV and XLS files and XLS cell data, and the file structure required for backup files.


PasteDown Panel

Access: Menu > View > PasteDown Panel, <Alt+A>, click number 4 on the Toolbar Toggle Pad (Top Toolbar A), Paste tab [image] when visible

The "Paste" functions that exist on popup menus in the Editor are convenient for pasting data into a single cell or a single column, but it's often helpful to be able to paste data from more than one tag field at a time. The PasteDown Panel fills this need by allowing the paste of any number of tag fields into multiple files selected in the Editor.

Clicking into any row in the Main Editor sets the PasteDown Panel's focus to that file and initiates a load of the file's tag into the left-hand pane. Each of the seven primary tag fields can be individually enabled or disabled for pasting by checking or unchecking respective check boxes on the right. Data in these fields may be edited before pasting. Tag fields in the right-hand pane have no edit boxes but may also be checked to have their field contents included in a paste. Only checked fields are pasted. To paste enabled tag fields into files in the Editor, select desired rows* in the Editor and press the Paste button [image].

Toggle: Checks/unchecks all tag fields in the left-hand pane.

Clear: Removes text from all fields in the PasteDown Panel. This will not remove data from the tag itself.

Data Source: Shows the tag type in view in the PasteDown Panel. May be clicked to select the type for MP3s, either the ID3v1 or ID3v2 tag.

Reload: Re-read the current file's tag into the left-hand pane.

Paste: Tag data in each enabled field is written to files selected in the Main Editor. The button takes on this appearance anytime one or more files are selected in the Main Editor.

± Buttons: Toggle buttons for enabling/disabling related groups of tag fields in the right-hand pane.

Close panel.

When saving Comments to multiple non-ID3v1 tags, caret symbols (^) in Comment fields are interpreted as newline characters. When saving to ID3v1 tags, these are automatically replaced with space characters before writing to the tag. See topic Comment Editor for additional details about multi-line Comments.

*Selecting Rows: Selecting files in the Main Editor is much like selecting files in a file browser. Here, however, the mouse is used on row numbers rather than on filenames. A single file is selected (highlighted) by clicking the mouse on the file's row number (first column). Click it again and it becomes unselected. Multiple files can be selected in several ways:

1) To select files one at a time, in any order, select the first one as above, then continue clicking additional row numbers to either add or remove rows from the selection.

2) To select consecutive files, position the mouse pointer over the first row number to be selected, then depress and hold down the left mouse button while dragging the mouse down or up the first column and across row numbers of the block of files you want to select. Repeat this process as needed to add additional files.

3) An alternate way to select consecutive files is to select the first file as described in 1) above, then hold the shift-key down while selecting the last. All files from the first to the last are selected. Repeat this process as needed to add additional files.

4) Select all rows at once by clicking the "Select All" button [image] on the Top Toolbar B.

Cancel row selections at any time by clicking anywhere on the main Editor, navigating to another page or window, or clicking the "Select All" button. Confirmations for saving tag data can be enabled or disabled in the Confirmations & Warnings section on in Preferences.


Sorting Tags

Access: Menu > View > Sort Panel, Sort Tab [image] on PasteDown Panel, <Alt+O>

Use Library Clinic's sort facilities to sort on up to five columns consecutively (an indexed sort), in either one of the two Main Editors.

In the example shown above, if the Sort Button were depressed, the Editor would first be sorted by Location, then all rows with same-Location would be sorted by artist, then all rows with same-artist sorted by album, and finally all rows with same-album sorted by track.

When folder nodes are active, each group of files at each folder location is sorted separately. When inactive, all listed files are sorted together as a single group, regardless of file location.

Choose columns upon which to sort beginning with the top, or 1st Pass, drop-down list, then work your way down through subsequent passes. The 1st Pass list is always enabled. After choosing a column to sort on in the 1st Pass, the check box for the 2nd Pass list becomes enabled. Checking the 2nd Pass checkbox causes the 2nd Pass list to become enabled, thus permitting selection of a 2nd Pass sort column. Continuing down the list in this manner allows up to five sort columns to be defined.

Press the Sort button to the right of the lists to begin sorting. Press the Clear button to remove all column selections. Check "Empties last" if you'd like empty Editor cells to carry the least "sort weight," such that empty cells fall at the end of a sorted list rather than at the beginning (this option can also be set with checkbox "Sort empty cells last" in Preferences on the "General 2" tab).

Use Preset Buttons 1 through 6 to Save, Recall, or Remove up to six favorite sort settings. Note that each Preset button can be used to perform any one of these three functions. Which function it performs depends upon which of the three Mode Buttons on the right is in the down position when the Preset button is depressed (the Recall button is shown in the "down" position above):

Save: When this mode button is down, pressing a Preset button saves the current sort configuration and associates it with the Preset button pressed. Once saved, this same Preset button can be used again later to reload the sort configuration again. To do this, the Recall mode button must placed in the down position first.

Recall: When this mode button is down, clicking a Preset button recalls a sort configuration that was previously associated with it by the pressing the button while the Save button was down. This loads the configuration back into the sort controls.

Remove: Clicking a Present button while in this mode clears a sort configuration that was associated with it using the Save control above.

Preset buttons that have sort configurations already associated with them have button numbers shown in bold. Empty buttons still available for association have numbers shown in regular type.

You can "fine tune" a sort order by holding the control key depressed while dragging individual row-number buttons around in the Main Editor with the mouse.

Other sorting options available:

Sort By Creation Time: Sorts a group of selected Editor files by their file age. Access: Menu > Edit > Sort By Creation Time <Ctrl+U>, or use the button [image] on the Speedbutton Toolbar

Sort Albums On Track: Performs an indexed album/track sort on selected Editor files. Sorts first by album name, then by track number within each album. Access: Menu > Edit > Sort Albums On Track <Ctrl+W>

Of course, sorting on any single data column can be done at any time simply by clicking on a column's header.


Specification Viewer

Access: Menu > View > Spec Sheet, Spec Sheet Tab [image] on PasteDown Panel, <Alt+S>

Use the Specifications Viewer to examine basic technical information about a selected file (click into a file's row in the Editor to have it examined). Information shown varies for each tag type. As an example, shown on the panel when an MP3 is selected is the following information, when available:

Duration: The play time of the selected file, given first in hours, minutes, & seconds, and in total seconds.

Version: The specific MPEG encoding version used to generate the file.

Type: The encoding bit rate and frequency, and whether the file is encoded in stereo or is monophonic. For non- VBR (Variable Bit Rate) files, the encoding bit rate shown is constant and applies to each frame in the file. For VBR files, this figure represents an average value for the file as a whole.

Frames: The length of each sound frame, followed by the number of frames contained in the file.

Sync: Confirms whether proper synchronization data was found in the file.

CRC: Confirms whether a cyclic redundancy check value was found in the file.

Copyright: Confirms whether the file contains copyright information.

Original: Confirms whether the file appears to be an original, unaltered version, or a copy.

VBR: Confirms whether the file is encoded with a Variable Bit Rate method.


Tag Lists and Audio Playlists

Tag Lists and Playlists

Saving Tag Lists (.csv, .doc, .htm, .txt, .xls, .xml)

Access: Menu > View > Save Taglist as > CSV,DOC,HTM,TXT,XLS, or XML <Ctrl+1> through <Ctrl+6>

Tag data displayed in the Main Editor can be saved in any of six possible file formats, available at Main Menu > File > Save tag list as…, or via the Speedbutton Toolbar:

CSV Format <Ctrl+1> Saves tag data to a symbol or character-delimited file (file extension ".csv").

DOC Format <Ctrl+2>* Saves tag data to an MS Word document (file extension ".doc").

HTM Format <Ctrl+3> Saves tag data to hypertext markup document (file extension ".htm").

TXT Format <Ctrl+4> Saves tag data to an ASCII text file (file extension ".txt").

XLS Format <Ctrl+5>* Saves tag data to an MS Excel document (file extension ".xls").

XML Format <Ctrl+6> Saves tag data to a v1.0 XML file (file extension ".xml").

Individual tag field columns are selected for inclusion in a list by checking their respective checkboxes in the "Include" section of the Save Dialog. If no rows are highlighted, files generated will include data for all tags listed in the Editor. If rows are selected, just data from selected rows are included. To create lists in a particular order, click on a column header to sort the Editor alphabetically on the data in that column, or use the Indexed Sort function on the Sort Tab to sort on multiple columns consecutively. To "fine tune" a sort order, any individual file can be dragged to another row in the Main Editor by holding the Control Key depressed while dragging its row number (first column) to another location. File extensions are generated automatically by the program.

Saving Playlists (.m3u)

Access: Menu > View > Save Playlist with > Relative Path/Absolute Path <Ctrl+7> or <Ctrl+8>, [image] or [image] toolbar buttons, popup menus in the Editor

File lists displayed in the Main Editor can be saved as a WinAMP*-style playlist (file extension ".m3u"). This function is available at Menu > File > Save playlist as..., from the Editor's file-column popup menu, or from the Browser's popup menu:

Save Playlist with. . . --> Relative Path <Ctrl+7> Creates a playlist containing only the names of the files themselves. The path to each file's location is not included in the list. This type of playlist must be placed in the same folder in which the files themselves reside, in order for WinAMP or other player to be able to find them. This selection is only made available if all files to be listed have the same path. The initial path presented for saving this type of list is always the path at which the listed files themselves are found.

Save Playlist with. . . --> Absolute Path <Ctrl+8> Creates playlists containing both file names and file locations. This type of playlist contains full paths to each file and can be placed in any folder and WinAMP* or other supporting program will be able to find them. The initial path presented for saving this type of list is governed by the Output Folder setting in Preferences.

Playlists will include all file names listed in the Main Editor if no rows are selected, or just files in selected rows if one or more rows are highlighted. Rough names for Playlists are auto-generated based upon the option setting Playlist Auto Name in Preferences. These can be overwritten with names of your own choosing. File extensions are generated automatically by the program.

Printing Tag Lists

Access: Menu > View > Print Settings <Ctrl+E>, Menu > View > Print Preview <Ctrl+F>, Menu > View > Print Tags <Ctrl+D>

Extensive, standard formatting controls are available at Menu > File > Print Settings for formatting printed tag lists. Individual tag fields (columns) can be included or excluded for printing on the Fields Tab in this dialog. The Print Settings dialog box contains a Mini-Preview Window on the right, for coarse observations of the effects of format changes, as they are made (if "Auto-update previews" is enabled in the "Options" section). For a more detailed preview, click the Preview Button, or exit the Print Settings dialog and choose Menu > File > Print Preview, to see how the tag list will actually look when printed. To print a list, you can 1) click the Print button in the Print Settings dialog, 2) click the Print button on the Preview Window when displayed, or 3) choose Menu > File > Print Tags after exiting the Print Settings dialog.

If specific files have not been selected (highlighted) in the Editor, a list is created using data from all files shown in the Editor; otherwise, only selected files are included in a Print Preview, or Printed list.


Technical Support

To report problems or to request technical assistance, click the "Support" link in the About Box (Main Menu > Help > About), or use the email address below.

Support Contact:

Keve Zoller

clinc@kevesoft.com


Toolbars

Top Toolbar A

Pictured above is the Top Toolbar in iTunes Mode. Left hand buttons are shown in "compact" form and may be expanded onto a separate tool bar directly beneath, with captions added (MainMenu > View > Top Buttons > Expanded, or <Alt+J>).

From left to right:

Link to tags (iTunes Mode) or iTunes (Tags Mode): When enabled in iTunes Mode, changes made to data in the iTunes library file are automatically propagated into corresponding file tags, where they exist. In Tags Mode, changes made to tag data are automatically propagated into corresponding library fields. Library Clinic supports many tag fields that are not supported in iTunes, and columns for these fields can only be made visible, and thus editable, in iTunes Mode when linking is enabled.

Catch up library file with tag changes (iTunes Mode only): Compares tag and library data and replaces library data with tag data where they differ (Ctrl+Alt+5) Does not remove data; changes or adds data only.

Catch up tags with library changes (not shown, Tags Mode only): Compares library and tag data and replaces tag data with library data where they differ (Ctrl+Alt+6). Does not remove data; changes or adds data only.

Save or Restore iTunes archive: Executes the archive editor. Save a copy of an iTunes library, install it back into iTunes at any time (Shif+F8).

Edit iTunes playlists: Executes the iTunes Playlist Editor (Ctrl+Alt+7).

Create new library: Creates a new, empty iTunes library file and executes the Add Files browse dialog to facilitate the addition of files to it (Shift+F1).

Add files to library: Opens a browse dialog for finding one or more files to add to the current library file. Remove files by highlighting rows you want to remove, left-clicking the mouse on the Editor, and choosing "Remove > Selected files" from the popup menu (Shift+F4).

Open library file: Executes a browse dialog for finding and opening any iTunes XML library file. In iTunes Mode the Browse button [image] also performs this function (Shift+F2).

Save library file: Saves changes made to the current file (Shift+F5).

Save library file as: Saves the current library file as an XML library file with a different name (Shift+F6).

Open iTunes library file: Opens the iTunes XML libary file "iTunes Music Library.xml" (Shif+F3).

Save as iTunes library file (Shift+F7): Installs the current file as the new iTunes XML libary file, "iTunes Music Library.xml." If the iTune's compressed library file exists ("iTunes Library.itl"), and it is not zero-length, backup copies of both these files are made first and stored in subfolder "Backups" in the install folder . A zero-length ITL file is then installed in place of the original ITL file. This will induce iTunes to load from the replacement XML file when next it runs. You can suppress the creation of backups during this process, if desired, by holding the Control Key depressed while executing. A backup can be selected for restoration by using the function at "Main Menu > iTunes > Restore iTunes backup." Visit "Backup file maintenance" to perform maintenance activities on accumulated backup files.

File Presence Indicators: Indicator "ITL" is green when an iTunes ITL library file ("iTunes Library.itl") is found to be present in the iTunes folder (and file length is greater than 0). Indicator "XML" is turned green when an iTunes XML library file ("iTunes Music Library.xml") is found present.

File-changed indicator: Visible whenever one or more changes have been logged for the current library file.

: Selects viewing mode, iTunes or Tags. In iTunes Mode, files in iTunes' XML library file (or other iTunes-formatted XML file) are listed. In Tags Mode, physical file tags are shown.

Refresh [image] or Stop [image] : The Refresh button reloads the current folders or file and refreshes all views and lists. While the program is counting files, loading files, and performing multi-file edit operations the icon changes to a "stop sign," which can be pressed to terminate the operation. Most types of multi-file operations can be either paused or canceled by clicking anywhere on the surface of the Editor or the file list on the Rename Page while an operation is in progress. Response times to cancellation clicks vary widely depending upon the type of operation being performed, the type of tag being operated upon, and the type of media upon which files are stored.

Folder Scanning enable/disable [image] or [image] : Click to enable or disable subfolder scanning when loading tags. When disabled, only files in the current folder are loaded into the Editor for viewing and editing. When enabled, files in the current folder plus all files in subfolders are loaded. If "Auto-refresh after scanning enabled/disabled" is checked in the Behavior section of Preferences, the view is automatically refreshed when this setting is changed, otherwise it is updated when a move to another folder is made, or the view is manually refreshed (see Refresh Button above).

Launch [image] or Close [image] iTunes: Start application iTunes, or close it if running (<Alt+8> and <Alt+9>, respectively).

Toolbar Toggle Pad [image] : Top horizontal button collectively toggles the visibility of the four Editor toolbars (Tag Type, Separator, Speedbutton, and the PasteDown Panel/Thumbnail Image Panel) between "all off" and the last configuration in which a toolbar was visible. The four numbered buttons beneath the horizontal bar toggle each of the four toolbars on or off separately.

Top Toolbar B

Tag: Editor page for editing an iTunes listing or physical file tags.

Rename: Page used for renaming all files listed in the Editor at one time, using tag content to form new names and/or paths.

Options Panel [image] : Accesses a roll-out panel containing auto-edit option settings for tag text edits in the Editor.

Column Properties [image] : Accesses a roll-out panel with controls for adjusting which data columns are visible and in what order they are listed.

Tag Data Source [image] : Indicator showing which tag type the Editor is listing. For MP3s, may be clicked to switch between ID3v1 and ID3v2.

Select All Rows [image] : Selects/deselects all rows at one time in the Editor.

Auto-Capitalization: Enables or disables Auto-Capitalization of edited tag text in the Editor. If Exact-Capitalization and/or Anti-Capitalization are enabled on the Options Panel, repeated button clicks cycle the capitalization style through available options:

If Anti-Cap and Exact-Cap are both enabled -

no cap options applied

Anti-Cap and Exact-Cap are applied*

Auto-Cap, Anti-Cap, then Exact-Cap are applied

If only Anti-Cap is enabled -

no cap options applied

Anti-Cap is applied*

Auto-Cap then Anti-Cap are applied

If only Exact-Cap is enabled -

no cap options applied

Exact-Cap is applied*

Auto-Cap then Exact-Cap are applied

*appears only when option "Only apply when Auto-Cap is enabled" is unchecked on the Capitalization Editor

Which tag fields that have auto-cap features applied to them is controlled by the "Apply To…" setting on the Options Panel and include three general categories of tag field types: Titles, Album Names, and/or People Names.

Current Folder: Normally occupied by a control showing the top-level directory or iTunes file being listed in the Editor. Double-clicking in the text box (or press F5) exchanges this default control for the "Find All Panel" for finding all occurrences of specific text in the Editor page:

Click the Find All Panel's "X" button to return to the Current Folder control, or double-click its text box (or use <Ctrl+B>, or MainMenu > Edit > MusicBrainz) to exchange it for the MusicBrainz Lookup Panel:

Click this panel's "X" button to return to the Current Folder control, or double-click on the panel ( or use <Alt+P>, or MainMenu > View > Player) to exchange it for the Internal Player Panel:

Click the Player Panel's "X" button to return to the Current Folder control.

File Mask: Sets the file type or types being listed.

Extract-To LED [image]: Displays a number or character indicating how far into each filename the Name-to-Tag Extraction process will extract data (either the 1st, 2nd, or 3rd Separator, or to the end of each filename). Indicator may be clicked to cycle through the options. or change the setting by visiting the "Separator" section on the Main Menu or on a popup menu, or by using the Separator ToolBar (see below).

Number Grouping LED [image]: Indicator and toggle switch showing whether Number Grouping is active [image] or disabled [image]. Click to toggle, or change the setting by visiting the "Separator" section on the Main Menu or on a popup menu, or by using the Separator ToolBar (see below).

Undo Rename or Move [image]: Reverses the last filename change(s) or file move.

File Type Toolbar

Access: Menu > View > Toolbars > Tag Type Bar, Toggle Pad button 1

Click on a file type button to have the Editor list only the file type or types indicated on the button (similar in function to the File Mask drop-down list on Toolbar 2, but offers faster access). In Tags Mode, either ID3v1 or ID3v2 tags can be listed for MP3s. To change the default type listed, right-click the button and choose it from the popup menu shown above.

Removes the toolbar from the Editor. Restore it again with the "1" button on the Toolbar Toggle Pad on the Top Toolbar (or go to Menu > View > Toolbars).

Separator Toolbar

Access: Menu > View > Toolbars > Separator Bar, Toggle Pad button 2

From left to right:

through [image] Chooses the active Separator for extracting blocks of text from file or path names into one or more Editor columns. The choice made here is also reflected in the Separator Indicator, on the Status Bar, the Main and Popup Menus, and on the Rename Page in the Separator drop-down list of Separators there. The choice of Separator can be applied to all pages collectively, or each page can be assigned its own Separator, depending upon the setting of option "Allow each page to have its own Separator" in the Behavior section of Preferences. For an explanation of the data extraction process, see section Name-to-Tag Extractions in this help file.

through [image] Choose how far into each file or path name the extraction process goes: up to the first Separator ( 1 ), the second Separator ( 2 ), the third ( 3 ), or all the way to the end of a name ( E ). The choice made here is also reflected on the Main and Popup Menus in their respective "Separator" sections, and by the "Extract to…" LED on Toolbar 2 (see above).

or [image] Choose whether to use file names or path names as the data source for name-to-tag extractions.

When enabled, groups of symbol-separated numbers are treated as a single contiguous group of numbers, when extracting data from name-to-tag. This allows, for example, a date like 9-12-2004 to be treated as a single block of text rather than a separate "9," then a "12," and finally a "2004." The setting here is also reflected by the "Number Grouping LED" on Toolbar 2 (see above), as well as on the Main and Popup Menus in their respective "Separator" sections. (See "Number Grouping" in topic Main Editor under main heading Multi-Tag POPUP Menu for a detailed discussion of this feature.)

Removes the toolbar from the Editor. Restore it again with the "2" button on the Toolbar Toggle Pad on the Top Toolbar (or go to Menu > View > Toolbars).

Speedbutton Toolbar

Access: Menu > View > Toolbars > Speedbutton Bar, Toggle Pad button 3

The Speedbutton Toolbar makes quick access available frequently-used functions, many of which are also available via Main Menu or popup menu. Most functions operate on all applicable files listed, if no rows are selected, or operate just on selected files if one or more rows are highlighted in the Editor.

Run the ID3v1 Genre List Editor (<Ctrl+G>). This list is only applicable when showing MP3 ID3v1 tags in the Editor.

Run the ID3v2 Genre List Editor (<Ctrl+H>). Used for all tags except MP3 ID3v1.

Run the Artist List Editor (<Ctrl+I>).

Run the Composer List Editor (<Ctrl+J>).

Run the Conductor List Editor (<Ctrl+L>).

Run the Orchestra List Editor (<Ctrl+N>).

Run the Encoder Settings List Editor (<Ctrl+Q>).

Run the Capitalization Editor (<Ctrl+S>).

Run the Illegal Character Replacement Editor (<<Ctrl+T>>).

Restore an iTunes backup file (<Shift+F9>).

Run the Backup File Maintenance Editor to examine or remove unwanted iTunes library backup files (<Shift+F10>).

Remove listings from a library for file listings that have a local hard drive address (<Shift+F11>).

Run the Missing File Maintenance Editor to selectively remove different types of listings from a library where no corresponding file is found (<Shift+F12>).

Create missing* ID3v1 tags from ID3v2 data in MP3 files (<Alt+F2>).

Fill in empty ID3v1 tag fields from ID3v2 tag data in MP3 files (<Alt+F3>).

Copy all ID3v2 tag data into corresponding ID3v1 fields in MP3 files (same function as "V2 -> V1 Row" on Editor popup menu).

Create missing* ID3v2 tags from ID3v1 data in MP3 files (<Alt-F4>).

Fill in empty ID3v2 tag fields from ID3v1 tag data in MP3 files (<Alt+F5>).

Copy all ID3v1 tag data into corresponding ID3v2 fields in MP3 files (same function as "V1 -> V2 Row" on Editor popup menu).

Create a relative-path playlist (<Ctrl+7>).

Create a absolute-path playlist (<Ctrl+7>).

Show/hide the Thumbnail Panel image viewer (<Alt+L>).

Initiate a lookup on MusicBrainz if one or more rows selected, or expose the MusicBrainz lookup panel if no rows are selected (<Alt+M>). Enabled on Windows XP and above only.

Search online for song lyrics and install in tag when found (<F8>). Requires valid artist and title.

Expose or hide internal player (player supports MP3 and WAVE files only, <Alt+Y>).

Play files in a WinAMP-style, playlist-supporting, associated player (same as "Play" on popup menu).

Enqueue all or selected files in a WinAMP-style, enqueue list-supporting, associated player (same as "Enqueue" on popup menu).

Auto-number tracks in selected rows. Numbering will begin with the number in the first selected track, if one is present, otherwise it begins with "1" (<Ctrl+Y>).

Remove tag (same as "Remove Tag" on popup menu, <Alt+11>).

Sort selected rows by their file creation date and time. Typically used to sort ripped CD songs by their disk order. This creates a sort order in which the auto-number track option above automatically installs the correct track number in respective tags (<Ctrl+U>).

Convert ID3v2.2 tags to ID3v2.3 tags (<Alt+F6>).

Convert ID3v2.3 tags to ID3v2.4 tags (<Alt+F7>).

Convert ID3v2.4 tags to ID3v2.3 tags (<Alt+F8>).

Convert ASCII text content to Unicode in ID3v2 tags (<Alt+9>).

Convert Unicode text content to ASCII in ID3v2 tags (<Alt+10>).

Find all occurrences of text or expression in tags in all listed files (<F5>).

Find text or expression in tags (<F3>).

Find next occurrence of text or expression in all listed files (<F4>).

Find occurrences of Text1 and replace them with Text2 in all listed files (<F6>).

Move tag data from the end of an M4A/MP4 to the front and rearranges tag field order for optimal streaming. This procedure is performed automatically after some tag alterations, such as after a picture or object is added or removed.

Get playtime for all or selected files.

Compress tag data in all or selected files with ID3v2 tags v2.3 or above (<Alt+F1>).

Print listed or selected tags (<Ctrl+D>).

Adjust print settings (<Ctrl+E>).

Print-preview a tag list (<Ctrl+F>).

Save tag list to a CSV-format file (<Ctrl+1>).

Save tag list to a file in MS Word format (<Ctrl+2>).

Save tag list to an HTML-formatted file (<Ctrl+3>).

Save tag list to a text file (<Ctrl+4>).

Save tag list to a file in MS Excel format (<Ctrl+5>).

Save tag list to a v1.0 XML format file (<Ctrl+6>).

Scroll buttons used to move the toolbar left or right to expose hidden buttons.

Removes the toolbar from the Editor. Restore it again with the "3" button on the Toolbar Toggle Pad on the Top Toolbar (or go to Menu > View > Toolbars).

*"missing" in this context means that there is no tag in the file being edited, or all tag fields in the tag being edited are empty.

PasteDown Panel

Access: Menu > View > Toolbars > PasteDown Panel, Toggle Pad button 4

See topic PasteDown Panel for details about this feature.


Tracks & Sets

Separate columns exist for Track, Total Tracks, Set, and Total Sets (refer to topic Column Order & Visibility to see how to expose or hide specific columns). The following discussion refers specifically to the behavior of the Track and Tracks columns, but it applies equally to the Set and Sets columns also.

By default, Track-type cells offer a "spin editor" when entered, which can be used to click to a particular number. Numbers can also be entered by hand. As with the drop-down lists presented in other types of cells, the presentation of spin editors in Track cells is optional and can be disabled in Preferences if desired.

Shown on the right in the image above is the Miscellaneous column, which has been configured to display a Track-Tracks combination view. This column is not directly editable but it can be configured to display Track-Tracks, Set-Sets, and many other types of tag field contents by running the Miscellaneous Editor: click the "ellipse button" that appears in any Miscellaneous column cell (or double-click one of these cells if double-click access has been enabled in Preferences).

It is possible to edit "Trks" numbers without the "Trks" column being visible. Key a backslash character into a "Trk" cell and the current "Track/Tracks" values are retrieved from the tag and presented in the cell together, separated by a backslash character:

You can add, remove, or edit either value manually when they are shown in this way. In addition, you can add or edit Tracks by pasting a number into one or more Track cells if you precede the number with a backslash. The program takes the presence of a leading backslash in a Track number as a signal that the number that follows it is to be entered into the Tracks number column, rather than the Track column itself. Also, you can paste just a backslash alone into a Track column to remove the corresponding Tracks number.

Leading zero support and other options are provided in Preferences section "Tracks/Sets" for fine tuning track and set behavior in Library Clinic.


URL Editor

Access: Click URL column cell button (Editor 2), or double-click the cell (depending upon Preferences setting)

URLs in ID3v2 tags

For MP3s, the ID3v2 Technical Specification allows for multiple user-defined URLs to exist in a single tag. The only restriction is that no two URL fields may have exactly the same Description. A single URL may be entered directly into a tag's URL cell in the Main Editor. Note that an empty URL cell (or one that contains non-URL data) can be left-clicked just like any other text cell to select its contents. A cell with a valid URL inside, however, appears blue and underlined, and when clicked will send the URL to your web browser for execution. To select the contents of a cell containing a "hot link," right-click it first to deactivate the link, then left-click it to select its contents. To add additional URLs, or to edit the optional Description field, click the "ellipse button" that appears to the right in this cell when the field is selected (subeditors can also be set to execute by double-clicking a cell - see topic Preferences):

This brings up the tag's URL contents in a stand-alone editor:

Click the More URLs button to access other URLs within the tag:

Click the "push-button" on the bottom panel to turn web links active in the editor. Active links are turned blue and become underlined, and a "pointing hand" cursor appears when the mouse is placed over one. Clicking on an active link sends the address to your web browser for execution. Right-clicking it temporarily deactivates it to allow editing.

Multiple URLs

Tags that contain multiple URLs, or a URL that's hidden from view, are flagged by a small red triangle appearing in the upper right corner of the URL data cell [image]. Hold the mouse pointer over a cell with this indicator and a hint-like box appears reporting the number of URLs present in the tag. For URLs that support multiple instances, use this Editor's "Add" button to insert an additional URL into a tag, or the "Delete" button to remove the one currently shown and selected.

In the Main Editor, a Delete operation via the Single-Tag Popup Menu (or the Delete key) operates only on the first instance of the displayed URL type, if multiple instances are present. Removing a URL from a tag that has more than one instance of a type results in the second one taking its place in the Editor's cell. To remove all instances at one time, use a Cut operation without doing a subsequent Paste, or use the Delete function on the Multi-Tag Popup Menu, or choose the "Remove All URLs" option on the URL Editor's main menu.


Volume Normalization

Access: MainMenu > File > Volume - Operates on selected rows, if rows are selected, or on all files if no rows are selected.

Multi-file Popup Menu > Volume - Operates on selected rows. Right-click Editor and choose "Volume" from the context menu.

Single-file Popup Menu - Operates on a single file. Right-click on any Volume cell.

MP3, M4A, and MP4 files that have been encoded with volume set too high or too low can be normalized by applying a command line program called AACgain.exe to the audio content. AACgain uses David Robinson's Replay Gain algorithm to calculate how loud the file sounds to the human ear, and increases or decreases the encoded volume accordingly. The audio itself is not altered.

Four normalization functions are supported in Library Clinic (refer to highlighted "Vol" column above):

1) Analyze Volume - Determine's the current volume level and places the result in the Volume Column.

2) Normalize Volume - Normalizes the volume and places the final volume level in the Volume Column. In most cases the original volume information is saved internally in the file and can be used to restore the original volume again using function 4) below. A small red triangle in the upper right corner of a volume cell denotes that normalization has been applied and that undo information is available.

3) Undo Normalization - Reverses a previous normalization and restores the original volume, if undo information was saved in the file when normalization was performed using function 2) above.

4) Remove Volume Data - Removes all analysis, normalization, and undo information from a file. Volume informaton is stored in an Ape tag at the end of MP3 files (field names 'REPLAYGAIN_TRACK_GAIN' and MP3GAIN_UNDO'), and in two free form strings in M4As and MP4s ('replaygain_track_gain' and 'replaygain_undo'). Executing this function removes these tag objects.

All volume levels are shown in decibels (dB).

The Volume Column is normally hidden from view by default. To expose it, check the "Volume (dB)" box on the Column Order & Visibility Panel. To pause or stop a multi-file normalization operation between files, click anywhere on the Editor's surface. This function does not support files with unicode names or paths.


Missing File Maintenance

Access: Main Menu > Itunes > Missing file maintenance, <Shift+F9>

Use the Missing File Editor to build a list of all files found in the currently loaded XML file that were not found when the file was loaded. These can occur if the files were added to the library at one time but have since been renamed, moved, deleted, or perhaps the path to them is not accessible. In the main Editor you can tell if missing files exist in the loaded file if the count of tags shown in the Status Bar is less than the total count of files listed in the file:

Use the button panel and Popup or Main Menus to select and remove any or all missing files found in the list.

Selected:

Select all files.

Remove selected files from the list.

Checked:

Toggle all files checked or unchecked.

Toggle all files that have a local hard drive path checked or unchecked. Missing local files can be removed without previewing them with this editor first by using program's Main Menu selection "iTunes > Remove missing local files."

Toggle all files that have a path on a removable device checked or unchecked.

Toggle all files with a network path checked or unchecked.

Toggle all MP3 files checked or unchecked.

Toggle all M4A files checked or unchecked.

Toggle all M4B files checked or unchecked.

Toggle all M4P files checked or unchecked.

Toggle all M4R files checked or unchecked.

Toggle all M4V files checked or unchecked.

Toggle all MP4 files checked or unchecked.

Toggle all WAV files checked or unchecked.

Remove checked files from the list.

To save the list to a Unicode text file for reference, choose "Main Menu > File > Save list to file," or <Alt+P>.